| **Documentation**                       | **Build Status**                           | **Code Coverage**               |
|:--------------------------------------- |:-------------------------------------------|:-------------------------------:|
|[![][docs-current-img]][docs-current-url]| [![Build Status][ci-img]][ci-url]          | [![][codecov-img]][codecov-url] |

!["colorschemes social media preview"](docs/src/assets/figures/colorschemes-social-media-preview.png)

## ColorSchemes

This package provides a collection of colorschemes:

- scientifically devised colorschemes from ColorBrewer, CMOcean, ScientificColorMaps, ColorCet, and Seaborn
- popular old favourites such as _viridis_, _inferno_, and _magma_ from MATPlotLib
- old masters' colorschemes, such as _leonardo_, _vermeer_, and _picasso_
- variously themed colorschemes such as _sunset_, _coffee_, _neon_, and _pearl_

Note that the schemes contained here are a mixture:

- some are high quality color maps with consistent perceptual contrast over their full range
- others are designed for general purpose and informal graphics work

Choose colorschemes with care! Refer to Peter Kovesi's [PerceptualColourMaps](https://github.com/peterkovesi/PerceptualColourMaps.jl) package, or to Fabio Crameri's [Scientific Colour Maps](http://www.fabiocrameri.ch/colourmaps.php) for more information.

If you want to make more advanced ColorSchemes, use linear-segment dictionaries or indexed lists, and use functions to generate color values, see the `make_colorscheme()` function in the [ColorSchemeTools.jl](https://github.com/JuliaGraphics/ColorSchemeTools.jl) package.

## Basic usage

```julia
] add ColorSchemes

using ColorSchemes

ColorSchemes.Purples_5 
# => a ColorScheme 

colorschemes[:Purples_5]
# => a ColorScheme 

ColorSchemes.Purples_5.colors
# => array of five RGB colors

ColorSchemes.Purples_5.colors[3]
# => the third color in the colorscheme

get(ColorSchemes.Purples_5, 0.5)
# => the midway point of the colorscheme

colorschemes
# => Dict{Symbol, ColorScheme} with 983 entries

findcolorscheme("purple")
# => display list of matching schemes

ColorScheme([colorant"red", colorant"green", colorant"blue"])
# new colorscheme from Colors.jl named colors

get(ColorSchemes.darkrainbow, range(0.0, 1.0, length=20)) |> ColorScheme
# new colorscheme by resampling existing
```

[docs-current-img]: https://img.shields.io/badge/docs-current-blue.svg
[docs-current-url]: https://JuliaGraphics.github.io/ColorSchemes.jl/dev/

[codecov-img]: https://codecov.io/gh/JuliaGraphics/ColorSchemes.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaGraphics/ColorSchemes.jl

[ci-img]: https://github.com/JuliaGraphics/ColorSchemes.jl/workflows/CI/badge.svg
[ci-url]: https://github.com/JuliaGraphics/ColorSchemes.jl/actions?query=workflow%3ACI

# color vision deficiency (CVD) -  (color blind) - friendly
# https://zenodo.org/record/3381072
# Creative Commons Attribution 4.0 International
# 8, 12, and 15 color palettes for deuteranopia color blindness
# Martin Krzywinski martink@bcgsc.ca
# Methods and details: http://mkweb.bcgsc.ca/colorblind

#From Paul Tol: https://personal.sron.nl/~pault/
loadcolorscheme(:tol_bright, [
    colorant"#4477AA",
    colorant"#EE6677",
    colorant"#228833",
    colorant"#CCBB44",
    colorant"#66CCEE",
    colorant"#AA3377",
    colorant"#BBBBBB"
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_highcontrast, [
    colorant"#004488",
    colorant"#DDAA33",
    colorant"#BB5566",
    ], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_vibrant, [
    colorant"#EE7733",
    colorant"#0077BB",
    colorant"#33BBEE",
    colorant"#EE3377",
    colorant"#CC3311",
    colorant"#009988",
    colorant"#BBBBBB",
    ], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_muted, [
    colorant"#332288",
    colorant"#88CCEE",
    colorant"#44AA99",
    colorant"#117733",
    colorant"#999933",
    colorant"#DDCC77",
    colorant"#CC6677",
    colorant"#882255",
    colorant"#AA4499",
    ], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_medcontrast, [
    colorant"#6699CC",
    colorant"#004488",
    colorant"#EECC66",
    colorant"#994455",
    colorant"#997700",
    colorant"#EE99AA",
    ], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_light, [
    colorant"#77AADD",
    colorant"#EE8866",
    colorant"#EEDD88",
    colorant"#FFAABB",
    colorant"#99DDFF",
    colorant"#44BB99",
    colorant"#BBCC33",
    colorant"#AAAA00",
    colorant"#DDDDDD"
    ], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_sunset, [
    colorant"#364B9A",
    colorant"#4A7BB7",
    colorant"#6EA6CD",
    colorant"#98CAE1",
    colorant"#C2E4EF",
    colorant"#EAECCC",
    colorant"#FEDA8B",
    colorant"#FDB366",
    colorant"#F67E4B",
    colorant"#DD3D2D",
    colorant"#A50026",
    ], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_BuRd, [
    colorant"#2166AC",
    colorant"#4393C3",
    colorant"#92C5DE",
    colorant"#D1E5F0",
    colorant"#F7F7F7",
    colorant"#FDDBC7",
    colorant"#F4A582",
    colorant"#D6604D",
    colorant"#B2182B",
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

colorschemes[:tol_bu_rd] = colorschemes[:tol_BuRd] # For compat.

loadcolorscheme(:tol_PRGn, [
    colorant"#762A83",
    colorant"#9970AB",
    colorant"#C2A5CF",
    colorant"#E7D4E8",
    colorant"#F7F7F7",
    colorant"#D9F0D3",
    colorant"#ACD39E",
    colorant"#5AAE61",
    colorant"#1B7837",
], "cvd", "cvd friendly, color blind friendly")

colorschemes[:tol_prgn] = colorschemes[:tol_PRGn] # For compat.

loadcolorscheme(:tol_nightfall, [
    colorant"#125A56",
    colorant"#00767B",
    colorant"#238F9D",
    colorant"#42A7C6",
    colorant"#60BCE9",
    colorant"#9DCCEF",
    colorant"#C6DBED",
    colorant"#DEE6E7",
    colorant"#ECEADA",
    colorant"#F0E6B2",
    colorant"#F9D576",
    colorant"#FFB954",
    colorant"#FD9A44",
    colorant"#F57634",
    colorant"#E94C1F",
    colorant"#D11807",
    colorant"#A01813"],
    "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_land_cover, [
    colorant"#5566AA",
    colorant"#117733",
    colorant"#44AA66",
    colorant"#55AA22",
    colorant"#668822",
    colorant"#99BB55",
    colorant"#558877",
    colorant"#88BBAA",
    colorant"#AADDCC",
    colorant"#44AA88",
    colorant"#DDCC66",
    colorant"#FFDD44",
    colorant"#FFEE88",
    colorant"#BB0011",
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

colorschemes[:ground_cover] = colorschemes[:tol_land_cover] # For compat.

loadcolorscheme(:tol_YlOrBr, [
    colorant"#FFFFE5",
    colorant"#FFF7BC",
    colorant"#FEE391",
    colorant"#FEC44F",
    colorant"#FB9A29",
    colorant"#EC7014",
    colorant"#CC4C02",
    colorant"#993404",
    colorant"#662506",
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

colorschemes[:tol_ylorbr] = colorschemes[:tol_YlOrBr]

loadcolorscheme(:tol_iridescent, [
    colorant"#FEFBE9",
    colorant"#FCF7D5",
    colorant"#F5F3C1",
    colorant"#EAF0B5",
    colorant"#DDECBF",
    colorant"#D0E7CA",
    colorant"#C2E3D2",
    colorant"#B5DDD8",
    colorant"#A8D8DC",
    colorant"#9BD2E1",
    colorant"#8DCBE4",
    colorant"#81C4E7",
    colorant"#7BBCE7",
    colorant"#7EB2E4",
    colorant"#88A5DD",
    colorant"#9398D2",
    colorant"#9B8AC4",
    colorant"#9D7DB2",
    colorant"#9A709E",
    colorant"#906388",
    colorant"#805770",
    colorant"#684957",
    colorant"#46353A",
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

colorschemes[:Iridescent] = colorschemes[:tol_iridescent] # For compat.

loadcolorscheme(:tol_incandescent, [
     colorant"#CEFFFF",
     colorant"#C6F7D6",
     colorant"#A2F49B",
     colorant"#BBE453",
     colorant"#D5CE04",
     colorant"#E7B503",
     colorant"#F19903",
     colorant"#F6790B",
     colorant"#F94902",
     colorant"#E40515",
     colorant"#A80003"
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

loadcolorscheme(:tol_rainbow, [
    colorant"#E8ECFB",
    colorant"#D9CCE3",
    colorant"#D1BBD7",
    colorant"#CAACCB",
    colorant"#BA8BD4",
    colorant"#AE76A3",
    colorant"#AA6F9E",
    colorant"#994F88",
    colorant"#882E72",
    colorant"#1965B0",
    colorant"#437DBF",
    colorant"#5289C7",
    colorant"#6195CF",
    colorant"#7BAFDE",
    colorant"#4EB265",
    colorant"#90C987",
    colorant"#CAE0AB",
    colorant"#F7F056",
    colorant"#F7CB45",
    colorant"#F6C141",
    colorant"#F4A736",
    colorant"#F1932D",
    colorant"#EE8026",
    colorant"#E8601C",
    colorant"#E65518",
    colorant"#DC050C",
    colorant"#A5170E",
    colorant"#72190E",
    colorant"#42150A",
], "cvd", "cvd friendly, color blind friendly, Paul Tol")

#From Color Universal Design (CUD): https://jfly.uni-koeln.de/color/
loadcolorscheme(:okabe_ito, [
    colorant"#E69F00",
    colorant"#56B4E9",
    colorant"#009E73",
    colorant"#F0E442",
    colorant"#0072B2",
    colorant"#D55E00",
    colorant"#CC79A7",
    colorant"#000000"
], "cvd", "cvd friendly, color blind friendly, Color Universal Design (CUD): https://jfly.uni-koeln.de/color/")

# 8, 12, and 15 color palettes for deuteranopia color blindness
# Martin Krzywinski martink@bcgsc.ca
# Methods and details: http://mkweb.bcgsc.ca/colorblind

loadcolorscheme(:mk_8, [
    colorant"#000000",
    colorant"#2271B2",
    colorant"#3DB7E9",
    colorant"#F748A5",
    colorant"#359B73",
    colorant"#d55e00",
    colorant"#e69f00",
    colorant"#f0e442",
], "cvd", "cvd friendly, color blind friendly, Martin Krzywinski")

loadcolorscheme(:mk_12, [
    colorant"#9F0162",
    colorant"#009F81",
    colorant"#FF5AAF",
    colorant"#00FCCF",
    colorant"#8400CD",
    colorant"#008DF9",
    colorant"#00C2F9",
    colorant"#FFB2FD",
    colorant"#A40122",
    colorant"#E20134",
    colorant"#FF6E3A",
    colorant"#FFC33B",
], "cvd", "cvd friendly, color blind friendly, Martin Krzywinski")

loadcolorscheme(:mk_15, [
    colorant"#68023F",
    colorant"#008169",
    colorant"#EF0096",
    colorant"#00DCB5",
    colorant"#FFCFE2",
    colorant"#003C86",
    colorant"#9400E6",
    colorant"#009FFA",
    colorant"#FF71FD",
    colorant"#7CFFFA",
    colorant"#6A0213",
    colorant"#008607",
    colorant"#F60239",
    colorant"#00E307",
    colorant"#FFDC3D",
], "cvd", "cvd friendly, color blind friendly, Martin Krzywinski")

loadcolorscheme(:ibm_cvd, [
    colorant"#648fff",
    colorant"#785ef0",
    colorant"#dc267f",
    colorant"#fe6100",
    colorant"#ffb000",
    colorant"#000000",
], "cvd", "cvd friendly, color blind friendly, IBM")

# https://arxiv.org/pdf/2107.02270.pdf
# https://github.com/mpetroff/accessible-color-cycles
# Matthew A. Petroff
loadcolorscheme(:mpetroff_6, [
    colorant"#5790fc",
    colorant"#f89c20",
    colorant"#e42536",
    colorant"#964a8b",
    colorant"#9c9ca1",
    colorant"#7a21dd",
], "cvd", "cvd friendly, color blind friendly, Matthew A. Petroff")

loadcolorscheme(:mpetroff_8, [
    colorant"#1845fb",
    colorant"#ff5e02",
    colorant"#c91f16",
    colorant"#c849a9",
    colorant"#adad7d",
    colorant"#86c8dd",
    colorant"#578dff",
    colorant"#656364",
], "cvd", "cvd friendly, color blind friendly, Matthew A. Petroff")

loadcolorscheme(:mpetroff_10, [
    colorant"#3f90da",
    colorant"#ffa90e",
    colorant"#bd1f01",
    colorant"#94a4a2",
    colorant"#832db6",
    colorant"#a96b59",
    colorant"#e76300",
    colorant"#b9ac70",
    colorant"#717581",
    colorant"#92dadd",
], "cvd", "cvd friendly, color blind friendly, Matthew A. Petroff")

using Documenter, Luxor, ColorSchemes

makedocs(
    modules = [ColorSchemes],
    sitename = "ColorSchemes",
    warnonly = true,
    format = Documenter.HTML(
        size_threshold = nothing,
        prettyurls = get(ENV, "CI", nothing) == "true",
        assets = ["assets/colorschemes-docs.css"]),
    pages = Any[
        "Introduction"      => "index.md",
        "Catalogue"         => "catalogue.md",
        "Basic usage"       => "basics.md",
        "Good practice"     => "goodpractice.md",
        "Finding colors"    => "finding.md",
        "Plotting"          => "plotting.md",
        "Images"            => "images.md",
        "Functions"         => "functionindex.md"
    ]
)

deploydocs(
    push_preview = true,
    repo = "github.com/JuliaGraphics/ColorSchemes.jl.git",
    target = "build"
)

loadcolorscheme(:tableau_10, [
    colorant"#4E79A7", # blue
    colorant"#F28E2B", # orange
    colorant"#E15759", # red
    colorant"#76B7B2", # turquoise
    colorant"#59A14F", # green
    colorant"#EDC948", # yellow
    colorant"#B07AA1", # purple
    colorant"#FF9DA7", # pink
    colorant"#9C755F", # brown
    colorant"#BAB0AC", # gray
], "tableau", "sequential")

# loadcolorscheme(:tableau_20, [ # original ordering
#     colorant"#4E79A7", colorant"#A0CBE8", # blue
#     colorant"#F28E2B", colorant"#FFBE7D", # orange
#     colorant"#59A14F", colorant"#8CD17D", # green
#     colorant"#B6992D", colorant"#F1CE63", # yellow
#     colorant"#499894", colorant"#86BCB6", # turquoise
#     colorant"#E15759", colorant"#FF9D9A", # red
#     colorant"#79706E", colorant"#BAB0AC", # gray
#     colorant"#D37295", colorant"#FABFD2", # pink
#     colorant"#B07AA1", colorant"#D4A6C8", # purple
#     colorant"#9D7660", colorant"#D7B5A6", # gray
# ], "tableau", "sequential")

loadcolorscheme(:tableau_20, [
    colorant"#4E79A7", colorant"#A0CBE8", # blue
    colorant"#F28E2B", colorant"#FFBE7D", # orange
    colorant"#E15759", colorant"#FF9D9A", # red
    colorant"#499894", colorant"#86BCB6", # turquoise
    colorant"#59A14F", colorant"#8CD17D", # green
    colorant"#B6992D", colorant"#F1CE63", # yellow
    colorant"#B07AA1", colorant"#D4A6C8", # purple
    colorant"#D37295", colorant"#FABFD2", # pink
    colorant"#9D7660", colorant"#D7B5A6", # brown
    colorant"#79706E", colorant"#BAB0AC", # gray
], "tableau", "sequential")

loadcolorscheme(:tableau_colorblind, [
    colorant"#1170aa",
    colorant"#fc7d0b",
    colorant"#a3acb9",
    colorant"#57606c",
    colorant"#5fa2ce",
    colorant"#c85200",
    colorant"#7b848f",
    colorant"#a3cce9",
    colorant"#ffbc79",
    colorant"#c8d0d9",
], "tableau", "sequential, cvd friendly color blind friendly")

loadcolorscheme(:tableau_seattle_grays, [
    colorant"#767f8b",
    colorant"#b3b7b8",
    colorant"#5c6068",
    colorant"#d3d3d3",
    colorant"#989ca3",
], "tableau", "sequential")

loadcolorscheme(:tableau_traffic, [
    colorant"#b60a1c",
    colorant"#e39802",
    colorant"#309143",
    colorant"#e03531",
    colorant"#f0bd27",
    colorant"#51b364",
    colorant"#ff684c",
    colorant"#ffda66",
    colorant"#8ace7e",
], "tableau", "sequential")

loadcolorscheme(:tableau_miller_stone, [
    colorant"#4f6980",
    colorant"#849db1",
    colorant"#a2ceaa",
    colorant"#638b66",
    colorant"#bfbb60",
    colorant"#f47942",
    colorant"#fbb04e",
    colorant"#b66353",
    colorant"#d7ce9f",
    colorant"#b9aa97",
    colorant"#7e756d",
], "tableau", "sequential")

loadcolorscheme(:tableau_superfishel_stone, [
    colorant"#6388b4",
    colorant"#ffae34",
    colorant"#ef6f6a",
    colorant"#8cc2ca",
    colorant"#55ad89",
    colorant"#c3bc3f",
    colorant"#bb7693",
    colorant"#baa094",
    colorant"#a9b5ae",
    colorant"#767676",
], "tableau", "sequential")

loadcolorscheme(:tableau_nuriel_stone, [
    colorant"#8175aa",
    colorant"#6fb899",
    colorant"#31a1b3",
    colorant"#ccb22b",
    colorant"#a39fc9",
    colorant"#94d0c0",
    colorant"#959c9e",
    colorant"#027b8e",
    colorant"#9f8f12",
], "tableau", "sequential")

loadcolorscheme(:tableau_jewel_bright, [
    colorant"#eb1e2c",
    colorant"#fd6f30",
    colorant"#f9a729",
    colorant"#f9d23c",
    colorant"#5fbb68",
    colorant"#64cdcc",
    colorant"#91dcea",
    colorant"#a4a4d5",
    colorant"#bbc9e5",
], "tableau", "sequential")

loadcolorscheme(:tableau_summer, [
    colorant"#bfb202",
    colorant"#b9ca5d",
    colorant"#cf3e53",
    colorant"#f1788d",
    colorant"#00a2b3",
    colorant"#97cfd0",
    colorant"#f3a546",
    colorant"#f7c480",
], "tableau", "sequential")

loadcolorscheme(:tableau_winter,[
    colorant"#90728f",
    colorant"#b9a0b4",
    colorant"#9d983d",
    colorant"#cecb76",
    colorant"#e15759",
    colorant"#ff9888",
    colorant"#6b6b6b",
    colorant"#bab2ae",
    colorant"#aa8780",
    colorant"#dab6af",
], "tableau", "sequential")

loadcolorscheme(:tableau_green_orange_teal, [
    colorant"#4e9f50",
    colorant"#87d180",
    colorant"#ef8a0c",
    colorant"#fcc66d",
    colorant"#3ca8bc",
    colorant"#98d9e4",
    colorant"#94a323",
    colorant"#c3ce3d",
    colorant"#a08400",
    colorant"#f7d42a",
    colorant"#26897e",
    colorant"#8dbfa8",
], "tableau", "sequential")

loadcolorscheme(:tableau_red_blue_brown, [
    colorant"#466f9d",
    colorant"#91b3d7",
    colorant"#ed444a",
    colorant"#feb5a2",
    colorant"#9d7660",
    colorant"#d7b5a6",
    colorant"#3896c4",
    colorant"#a0d4ee",
    colorant"#ba7e45",
    colorant"#39b87f",
    colorant"#c8133b",
    colorant"#ea8783",
], "tableau", "sequential")

loadcolorscheme(:tableau_purple_pink_gray, [
    colorant"#8074a8",
    colorant"#c6c1f0",
    colorant"#c46487",
    colorant"#ffbed1",
    colorant"#9c9290",
    colorant"#c5bfbe",
    colorant"#9b93c9",
    colorant"#ddb5d5",
    colorant"#7c7270",
    colorant"#f498b6",
    colorant"#b173a0",
    colorant"#c799bc",
], "tableau", "sequential")

loadcolorscheme(:tableau_hue_circle, [
    colorant"#1ba3c6",
    colorant"#2cb5c0",
    colorant"#30bcad",
    colorant"#21B087",
    colorant"#33a65c",
    colorant"#57a337",
    colorant"#a2b627",
    colorant"#d5bb21",
    colorant"#f8b620",
    colorant"#f89217",
    colorant"#f06719",
    colorant"#e03426",
    colorant"#f64971",
    colorant"#fc719e",
    colorant"#eb73b3",
    colorant"#ce69be",
    colorant"#a26dc2",
    colorant"#7873c0",
    colorant"#4f7cba",
], "tableau", "sequential")

loadcolorscheme(:tableau_orange_blue,[
    colorant"#9e3d22",
    colorant"#d45b21",
    colorant"#f69035",
    colorant"#d9d5c9",
    colorant"#77acd3",
    colorant"#4f81af",
    colorant"#2b5c8a",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_green, [
    colorant"#a3123a",
    colorant"#e33f43",
    colorant"#f8816b",
    colorant"#ced7c3",
    colorant"#73ba67",
    colorant"#44914e",
    colorant"#24693d",
], "tableau", "diverging")

loadcolorscheme(:tableau_green_blue,[
    colorant"#24693d",
    colorant"#45934d",
    colorant"#75bc69",
    colorant"#c9dad2",
    colorant"#77a9cf",
    colorant"#4e7fab",
    colorant"#2a5783",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_blue, [
    colorant"#a90c38",
    colorant"#e03b42",
    colorant"#f87f69",
    colorant"#dfd4d1",
    colorant"#7eaed3",
    colorant"#5383af",
    colorant"#2e5a87",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_black, [
    colorant"#ae123a",
    colorant"#e33e43",
    colorant"#f8816b",
    colorant"#d9d9d9",
    colorant"#a0a7a8",
    colorant"#707c83",
    colorant"#49525e",
], "tableau", "diverging")

loadcolorscheme(:tableau_gold_purple,[
    colorant"#ad9024",
    colorant"#c1a33b",
    colorant"#d4b95e",
    colorant"#e3d8cf",
    colorant"#d4a3c3",
    colorant"#c189b0",
    colorant"#ac7299",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_green_gold, [
    colorant"#be2a3e",
    colorant"#e25f48",
    colorant"#f88f4d",
    colorant"#f4d166",
    colorant"#90b960",
    colorant"#4b9b5f",
    colorant"#22763f",
], "tableau", "diverging")

loadcolorscheme(:tableau_sunset_sunrise, [
    colorant"#33608c",
    colorant"#9768a5",
    colorant"#e7718a",
    colorant"#f6ba57",
    colorant"#ed7846",
    colorant"#d54c45",
    colorant"#b81840",
], "tableau", "diverging")

loadcolorscheme(:tableau_orange_blue_white, [
    colorant"#9e3d22",
    colorant"#e36621",
    colorant"#fcad52",
    colorant"#ffffff",
    colorant"#95c5e1",
    colorant"#5b8fbc",
    colorant"#2b5c8a",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_green_white, [
    colorant"#ae123a",
    colorant"#ee574d",
    colorant"#fdac9e",
    colorant"#ffffff",
    colorant"#91d183",
    colorant"#539e52",
    colorant"#24693d",
], "tableau", "diverging")

loadcolorscheme(:tableau_green_blue_white, [
    colorant"#24693d",
    colorant"#529c51",
    colorant"#8fd180",
    colorant"#ffffff",
    colorant"#95c1dd",
    colorant"#598ab5",
    colorant"#2a5783",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_blue_white, [
    colorant"#a90c38",
    colorant"#ec534b",
    colorant"#feaa9a",
    colorant"#ffffff",
    colorant"#9ac4e1",
    colorant"#5c8db8",
    colorant"#2e5a87",
], "tableau", "diverging")

loadcolorscheme(:tableau_red_black_white, [
    colorant"#ae123a",
    colorant"#ee574d",
    colorant"#fdac9d",
    colorant"#ffffff",
    colorant"#bdc0bf",
    colorant"#7d888d",
    colorant"#49525e",
], "tableau", "diverging")

loadcolorscheme(:tableau_orange_blue_light, [
    colorant"#ffcc9e",
    colorant"#f9d4b6",
    colorant"#f0dccd",
    colorant"#e5e5e5",
    colorant"#dae1ea",
    colorant"#cfdcef",
    colorant"#c4d8f3",
], "tableau", "diverging")

loadcolorscheme(:tableau_temperature, [
    colorant"#529985",
    colorant"#6c9e6e",
    colorant"#99b059",
    colorant"#dbcf47",
    colorant"#ebc24b",
    colorant"#e3a14f",
    colorant"#c26b51",
], "tableau", "diverging")

loadcolorscheme(:tableau_blue_green, [
    colorant"#feffd9",
    colorant"#f2fabf",
    colorant"#dff3b2",
    colorant"#c4eab1",
    colorant"#94d6b7",
    colorant"#69c5be",
    colorant"#41b7c4",
], "tableau", "sequential")

loadcolorscheme(:tableau_blue_light, [
    colorant"#e5e5e5",
    colorant"#e0e3e8",
    colorant"#dbe1ea",
    colorant"#d5dfec",
    colorant"#d0dcef",
    colorant"#cadaf1",
    colorant"#c4d8f3",
], "tableau", "sequential")

loadcolorscheme(:tableau_orange_light, [
    colorant"#e5e5e5",
    colorant"#ebe1d9",
    colorant"#f0ddcd",
    colorant"#f5d9c2",
    colorant"#f9d4b6",
    colorant"#fdd0aa",
    colorant"#ffcc9e",
], "tableau", "sequential")

# Australian bird inspired color schemes

# Sourced from <https://github.com/shandiya/feathers>

loadcolorscheme(:spotted_pardalote, [
        colorant"#feca00",
        colorant"#d36328",
        colorant"#cb0300",
        colorant"#b4b9b3",
        colorant"#424847",
        colorant"#000100",
    ],
    "Feathers",
    "bird, Spotted Pardalote (Pardalotus punctatus)")

loadcolorscheme(:plains_wanderer, [
        colorant"#edd8c5",
        colorant"#d09a5e",
        colorant"#e7aa01", 
        colorant"#ac570f", 
        colorant"#73481b",
        colorant"#442c0e",
        colorant"#0d0403",
    ],
    "Feathers",
    "bird, Plains Wanderer (Pedionomus torquatus)")

loadcolorscheme(:bee_eater, [
        colorant"#00346E",
        colorant"#007CBF",
        colorant"#06ABDF",
        colorant"#EDD03E",
        colorant"#F5A200",
        colorant"#6D8600",
        colorant"#424D0C",
    ],
    "Feathers",
    "bird, Bee Eater (Merops ornatus)")

loadcolorscheme(:rose_crowned_fruit_dove, [
        colorant"#BD338F",
        colorant"#EB8252",
        colorant"#F5DC83",
        colorant"#CDD4DC",
        colorant"#8098A2",
        colorant"#8FA33F",
        colorant"#5F7929",
        colorant"#014820",
    ],
    "Feathers",
    "bird, Rose-crowned Fruit Dove (Ptilinopus regina)")

loadcolorscheme(:eastern_rosella, [
        colorant"#cd3122",
        colorant"#f4c623",
        colorant"#bee183",
        colorant"#6c905e",
        colorant"#2f533c",
        colorant"#b8c9dc",
        colorant"#2f7ab9",
    ],
    "Feathers",
    "bird, Eastern Rosella (Platycercus eximius)")

loadcolorscheme(:oriole, [
        colorant"#8a3223",
        colorant"#bb5645",
        colorant"#d97878",
        colorant"#e2aba0",
        colorant"#d0cfe9",
        colorant"#a29eb8",
        colorant"#6c6b75",
        colorant"#b8a53f",
        colorant"#93862a",
        colorant"#4d4019",
    ],
    "Feathers",
    "bird, Oriole (Oriolus sagittatus)")

loadcolorscheme(:princess_parrot, [
        colorant"#7090c9",
        colorant"#8cb3de",
        colorant"#afbe9f",
        colorant"#616020",
        colorant"#6eb245",
        colorant"#214917",
        colorant"#cf2236",
        colorant"#d683ad",
    ],
    "Feathers",
    "bird, Princess Parrot (Polytelis alexandrae)")

loadcolorscheme(:superb_fairy_wren, [
        colorant"#4F3321",
        colorant"#AA7853",
        colorant"#D9C4A7",
        colorant"#B03F05",
        colorant"#020503",
    ],
    "Feathers",
    "bird, Superb Fairy Wren (Malurus cyaneus)")

loadcolorscheme(:cassowary, [
        colorant"#BDA14D",
        colorant"#3EBCB6",
        colorant"#0169C4",
        colorant"#153460",
        colorant"#D5114E",
        colorant"#A56EB6",
        colorant"#4B1C57",
        colorant"#09090C",
    ],
    "Feathers",
    "bird, Cassowary (Casuarius casuarius)")

loadcolorscheme(:yellow_robin, [
        colorant"#E19E00",
        colorant"#FBEB5B",
        colorant"#85773A",
        colorant"#979EB9",
        colorant"#727B98",
        colorant"#454B56",
        colorant"#201B1E",
    ],
    "Feathers",
    "bird, Yellow Robin (Eopsaltria australis)")

loadcolorscheme(:galah, [
        colorant"#FFD2CF",
        colorant"#E9A7BB",
        colorant"#D05478",
        colorant"#AAB9CC",
        colorant"#8390A2",
        colorant"#4C5766",
    ],
    "Feathers",
    "bird, Galah (Eolophus roseicapilla)")

 loadcolorscheme(:kookaburra, [
        colorant"#b5effb",
        colorant"#0b7595",
        colorant"#02407c",
        colorant"#06213a",
        colorant"#c45829",
        colorant"#9C4620",
        colorant"#622C14",
        colorant"#d4d8e3",
        colorant"#b8bcd8",
        colorant"#ad8d9f",
        colorant"#725f77",
    ],
  "Feathers",
  "bird, Blue winged Kookaburra (Dacelo leachii)")

# color values from https://www.flagcolorcodes.com/progress-pride

# The Pride Progress Flag was designed in 2018 by graphic designer Daniel Quasar
# the six colors from Gilbert Baker's flag
# plus colors for skin color
# plus colors from flag for the trans community: 
# "the traditional color, light blue, for boys, pink for girls, and a
# single white stripe for those who are transitioning, gender neutral, or
# intersex."

# hexcodes = [
# "#E40303", # red
# "#FF8C00", # orange
# "#FFED00", # yellow
# "#008026", # green
# "#24408E", # indigo
# "#732982", # violet
# "#FFFFFF", # white
# "#FFAFC8", # pink
# "#74D7EE", # light blue
# "#613915", # brown
# "#000000", # black
# ]
# colvalues = map(c -> parse(Colorant, c), hexcodes)

loadcolorscheme(:progress, [
    RGB{Float64}(0.894,0.012,0.012), # red LGBT 1/6 
    RGB{Float64}(1.0, 0.549, 0.0), # orange LGBT 2/6 
    RGB{Float64}(1.0, 0.929, 0.0), # yellow LGBT 3/6 
    RGB{Float64}(0.0, 0.502, 0.149), # green LGBT 4/6  
    RGB{Float64}(0.141, 0.251, 0.557), # indigo LGBT 5/6 
    RGB{Float64}(0.451, 0.161, 0.51), # violet LGBT 6/6 
    RGB{Float64}(1.0,1.0,1.0), # white trans 1/3
    RGB{Float64}(1.0,0.686,0.784), # pink trans 2/3
    RGB{Float64}(0.455,0.843,0.933), # light blue trans 3/3
    RGB{Float64}(0.38,0.224,0.082), # brown progress 1/2
    RGB{Float64}(0.0,0.0,0.0), # black progress 2/2
], "pride", "pride progress gay trans LGBT LGBTQ"
)

"""
The ColorSchemes module provides simple access to color schemes (arrays of colors).

Use `get(cscheme, n)` with n varying from 0 to 1 to find a color at that point
in the color scheme `cscheme`, where 0 is the leftmost color, and 1 the rightmost.

Access the scheme's colors directly using `cscheme.colors`.

See also `getinverse()`.
"""
module ColorSchemes

import Base.get, Base.reverse, Base.*

using Colors, ColorTypes, FixedPointNumbers
import ColorVectorSpace

export ColorScheme,
       get,
       getinverse,
       colorschemes,
       loadcolorscheme,
       findcolorscheme,
       ColorSchemeCategory,
       ColourScheme,
       colourschemes,
       loadcolourscheme,
       findcolourscheme,
       resample,
       ColourSchemeCategory

"""
    ColorScheme(colors, category, notes)

Create a ColorScheme from an array of colors. You can also name it, assign a
category to it, and add notes.

```julia
myscheme = ColorScheme([Colors.RGB(0.0, 0.0, 0.0), Colors.RGB(1.0, 1.0, 1.0)],
    "custom", "twotone, black and white")
```

"""
struct ColorScheme{V <: AbstractVector{<:Colorant},S1 <: AbstractString,S2 <: AbstractString}
    colors::V
    category::S1
    notes::S2
end

ColorScheme(colors::V, category::S1 = "", notes::S2 = "") where {V,S1,S2} =
    ColorScheme{V,S1,S2}(colors, category, notes)

# displaying swatches
Base.show(io::IO, m::MIME"image/svg+xml", cscheme::ColorScheme) = show(io, m, cscheme.colors)

# for making the catalogue pages in the docs
struct ColorSchemeCategory
    name :: String
end

Base.getindex(cs::ColorScheme, i::AbstractFloat) = get(cs, i)
Base.getindex(cs::ColorScheme, i::AbstractVector{<: AbstractFloat}) = get(cs, i)

"""
    loadcolorscheme(vname, colors, cat="", notes="")

Define a ColorScheme from a symbol and an array of colors,
and add it to the `colorschemes` dictionary. Optionally
specify a category and some notes.

### Example

This is an example (from `ColorsSchemes/data/flags.jl`) of how the supplied colorschemes are
loaded into the ColorSchemes dictionary.

```julia
loadcolorscheme(:flag_nu, [
        RGB(0.7843137254901961, 0.06274509803921569, 0.1803921568627451),
        RGB(0.00392156862745098, 0.12941176470588237, 0.4117647058823529),
        RGB(1.0, 1.0, 1.0),
        RGB(0.996078431372549, 0.8666666666666667, 0.0),
    ], "flags", "The flag of Niue")
```
"""
function loadcolorscheme(vname, colors, cat = "", notes = "")
    haskey(colorschemes, vname) && println("$vname overwritten")
    colorschemes[vname] = ColorSchemes.ColorScheme(colors, cat, notes)
    return colorschemes[vname]
end

"""
    colorschemes

An exported dictionary of pre-defined colorschemes:

```julia
colorschemes[:summer] |> show
   ColorScheme(
      ColorTypes.RGB{Float64}[
          RGB{Float64}(0.0,0.5,0.4), RGB{Float64}(0.01,0.505,0.4), RGB{Float64}(0.02,0.51,0.4), RGB{Float64}(0.03,0.515,0.4),
          ...
```

To choose a random ColorScheme:

```julia
scheme = rand(keys(colorschemes))
```

"""
const colorschemes = Dict{Symbol,ColorScheme}()

"""
    loadallschemes()

Load all colorschemes from data files. Not exported.
"""
function loadallschemes()
    # load the installed schemes
    datadir = joinpath(dirname(@__DIR__), "data")
    include(joinpath(datadir, "allcolorschemes.jl"))
    include(joinpath(datadir, "colorbrewerschemes.jl"))
    include(joinpath(datadir, "matplotlib.jl"))
    include(joinpath(datadir, "cmocean.jl"))
    include(joinpath(datadir, "sampledcolorschemes.jl"))
    include(joinpath(datadir, "gnu.jl"))
    include(joinpath(datadir, "colorcetdata.jl"))
    include(joinpath(datadir, "cmasher.jl"))
    include(joinpath(datadir, "scicolor.jl"))
    include(joinpath(datadir, "seaborn.jl"))
    include(joinpath(datadir, "tableau.jl"))
    include(joinpath(datadir, "cvd.jl"))
    include(joinpath(datadir, "flags.jl"))
    include(joinpath(datadir, "websafe.jl"))
    include(joinpath(datadir, "metbrewer.jl"))
    include(joinpath(datadir, "jcolors.jl"))
    include(joinpath(datadir, "nord.jl"))
    include(joinpath(datadir, "fastie.jl"))
    include(joinpath(datadir, "kindlmann.jl"))
    include(joinpath(datadir, "pnw.jl"))
    include(joinpath(datadir, "wesanderson.jl"))
    include(joinpath(datadir, "ghibli.jl"))
    include(joinpath(datadir, "feathers.jl"))
    include(joinpath(datadir, "progress.jl"))
    include(joinpath(datadir, "catppuccin_scheme.jl"))

    # create them as constants...
    for key in keys(colorschemes)
        @eval const $key = colorschemes[$(QuoteNode(key))]
    end
end

loadallschemes()

"""
    findcolorscheme(str;
        search_notes=true)

Find all colorschemes matching `str`. `str` is interpreted
as a regular expression (case-insensitive).

This returns an array of symbols which are the names of
matching schemes in the `colorschemes` dictionary.

```julia
julia> findcolorscheme("ice")

colorschemes containing "ice"

  seaborn_icefire_gradient
  seaborn_icefire_gradient  (notes) sequential, ice fire gradient...
  ice
  flag_is               (notes) The flag of Iceland...
  botticelli
  botticelli            (notes) palette from artist Sandro Bot...


 ...found 6 results for "ice"
```

To read the notes of a built-in colorscheme `cscheme`:

```julia
colorschemes[:cscheme].notes
```
"""
function findcolorscheme(str;
    search_notes = true)
    println("\ncolorschemes containing \"$str\"\n")
    counter = 0
    found   = Symbol[]
    for (k, v) in colorschemes
        if occursin(Regex(str, "i"), string(k))
            # found in name
            printstyled("  $(rpad(k, 20))\n", bold = true)
            counter += 1
            push!(found, k)
        elseif occursin(Regex(str, "i"), string(v.category))
            # found in category
            printstyled("  $(rpad(k, 20))", bold = true)
            println(" (category) $(v.category)")
            counter += 1
            push!(found, k)
        end
        if occursin(Regex(str, "i"), string(v.notes)) && search_notes == true
            # found in notes
            # avoid duplication
            if k ∉ found
                printstyled("  $(rpad(k, 20))", bold = true)
                l = min(30, length(v.notes))
                println("  (notes) $(v.notes[1:l])...")
                counter += 1
                push!(found, k)
            end
        end
    end
    if counter > 0
        println("\n\n ...found $counter result$(counter > 1 ? "s" : "") for \"$str\"")
    else
        println("\n\n ...nothing found for \"$str\"")
    end
    return found
end

# Interfaces
Base.length(cscheme::ColorScheme) = length(cscheme.colors)
Base.getindex(cscheme::ColorScheme, I) = cscheme.colors[I]
Base.size(cscheme::ColorScheme) = length(cscheme.colors)
Base.IndexStyle(::Type{<:ColorScheme}) = IndexLinear()

# iterable
function Base.iterate(cscheme::ColorScheme)
    if length(cscheme.colors) == 0
        return nothing
    end
    return (first(cscheme.colors), 1)
end

function Base.iterate(cscheme::ColorScheme, state)
    if state >= length(cscheme.colors)
        return nothing
    else
        return (cscheme.colors[state + 1], state + 1)
    end
end

Base.firstindex(cscheme::ColorScheme) = firstindex(cscheme.colors)
Base.lastindex(cscheme::ColorScheme) = lastindex(cscheme.colors)

# utility lerping function to convert a value between oldmin/oldmax to equivalent value between newmin/newmax
remap(value, oldmin, oldmax, newmin, newmax) =
    ((value .- oldmin) ./ (oldmax .- oldmin)) .* (newmax .- newmin) .+ newmin

const AllowedInput = Union{<:Real,AbstractArray{<:Real}}

defaultrange(x::Real) = zero(x), oneunit(x)
defaultrange(x::AbstractArray) = zero(eltype(x)), oneunit(eltype(x))

"""
    get(cscheme::ColorScheme, inData :: Array{Number, 2}, rangescale=:clamp)
    get(cscheme::ColorScheme, inData :: Array{Number, 2}, rangescale=(minVal, maxVal))

Return an RGB array of colors generated by applying the
colorscheme to the 2D input data.

If `rangescale` is `:clamp` the colorscheme is applied to
values between 0.0-1.0, and values outside this range get
clamped to the ends of the colorscheme.

If `rangescale` is `:extrema`, the colorscheme is
applied to the range `minimum(indata)..maximum(indata)`.

Else, if `rangescale` is `:centered`, the colorscheme is
applied to the range `-maximum(abs, indata)..maximum(abs, indata)`.

TODO: this function expects the colorscheme to consist of
RGB [0.0-1.0] values. It should work with more colortypes.

# Examples

```julia
img = get(colorschemes[:leonardo], rand(10,10)) # displays in Juno Plots window, but
save("testoutput.png", img)      # you'll need FileIO or similar to do this

img2 = get(colorschemes[:leonardo], 10.0 * rand(10, 10), :extrema)
img3 = get(colorschemes[:leonardo], 10.0 * rand(10, 10), (1.0, 9.0))

# Also works with PerceptualColourMaps
using PerceptualColourMaps # warning, installs PyPlot, PyCall, LaTeXStrings
img4 = get(PerceptualColourMaps.cmap("R1"), rand(10,10))

# resample an existing scheme to make a new one
get(ColorSchemes.darkrainbow, range(0.0, 1.0, length=13)) |> ColorScheme
```
"""
function get(cscheme::ColorScheme, x::AllowedInput, rangemode::Symbol)
    rangescale = if rangemode === :clamp
        defaultrange(x)
    elseif rangemode === :extrema
        extrema(x)
    elseif rangemode === :centered
        (-1, 1) .* maximum(abs, x)
    else
        throw(ArgumentError("rangescale :$rangemode not supported, should be :clamp, :extrema, :centered or tuple (minVal, maxVal)"))
    end
    return get(cscheme, x, rangescale)
end

# optimized get(colorscheme, data) function #91 stevengj
# faster weighted_color_mean that assumes w ∈ [0,1] and
# exploits ColorVectorSpace operations for RGB and Gray types.
fast_weighted_color_mean(w::Real, c1, c2) = Colors.weighted_color_mean(w, c1, c2)
fast_weighted_color_mean(w::Real, c1::ColorVectorSpace.MathTypes, c2::ColorVectorSpace.MathTypes) = w*c1 + (1-w)*c2

function get(cscheme::ColorScheme, X::AllowedInput, rangescale::NTuple{2, <:Real} = defaultrange(X))
    rangemin, rangemax = !iszero(rangescale[2] - rangescale[1]) ?
                         rangescale : (zero(rangescale[1]), oneunit(rangescale[2]))
    scaleby = (length(cscheme) - 1) / (rangemax - rangemin)
    return map(X) do x
        xclamp = clamp(x, rangemin, rangemax)
        before_fp = (xclamp - rangemin) * scaleby + 1
        before = round(Int, before_fp, RoundDown)
        after = min(before + 1, length(cscheme))
        cpt = before_fp - before
        #  blend between the two colors adjacent to the point
        @inbounds fast_weighted_color_mean(1 - cpt, cscheme.colors[before], cscheme.colors[after])
    end
end

# Boolean just takes the start and end values of the scheme. Also avoid using a branch.
function get(cscheme::ColorScheme, x::Union{Bool, AbstractArray{Bool}})
    i = x .* (length(cscheme) .- 1) .+ 1
    return getindex.(Ref(cscheme.colors), i)
end

"""
    get(cs::ColorScheme, g::Color{T,1} where T<:Union{Bool, AbstractFloat, FixedPoint})

Return the color in `cs` that corresponds to the gray value `g`.
"""
function get(cs::ColorScheme, g::Color{T, 1} where {T <: Union{Bool, AbstractFloat, FixedPoint}})
    return get(cs, ColorTypes.gray(g)) # don't confuse with the 'grays' colorscheme
end

"""
    getinverse(cscheme::ColorScheme, c, range=(0.0, 1.0))

Computes where the provided Color `c` would fit in `cscheme`.

This is the inverse of `get()` — it returns the value `x` in the provided `range`
for which `get(scheme, x)` would most closely match the provided Color `c`.

# Examples

The first example asks: "where in the `leonardo` colorscheme will I find the nearest
color to red?":

```julia
julia> getinverse(colorschemes[:leonardo], RGB(1, 0, 0))
0.6248997995654847

julia> getinverse(ColorScheme([Colors.RGB(0,0,0), Colors.RGB(1,1,1)]),  Colors.RGB(.5,.5,.5))
0.5432555858022048

julia> cs = ColorScheme(range(Colors.RGB(0,0,0), stop=Colors.RGB(1,1,1), length=5))

julia> getinverse(cs, cs[3])
0.5
```
"""
function getinverse(cscheme::ColorScheme, c, rangescale::Tuple{Number, Number} = (0.0, 1.0))
    # TODO better error handling please
    length(cscheme) <= 1 && throw(ErrorException("ColorScheme of length $(length(cscheme)) is not long enough"))
    cdiffs = map(c_i -> colordiff(promote(c, c_i)...), cscheme.colors)
    closest = argmin(cdiffs)
    left = right = 0
    if closest == 1
        left = closest
        right = closest + 1
    elseif closest == length(cscheme)
        left = closest - 1
        right = closest
    else
        next_closest = cdiffs[closest - 1] < cdiffs[closest + 1] ? closest - 1 : closest + 1
        left = min(closest, next_closest)
        right = max(closest, next_closest)
    end
    v = left
    if cdiffs[left] != cdiffs[right] # prevents divide by zero
        v += (cdiffs[left] / (cdiffs[left] + cdiffs[right]))
    end
    return remap(v, 1, length(cscheme), rangescale...)
end

"""
    reverse(cscheme)

Make a new ColorScheme with the same colors as `cscheme` but in reverse order.
"""
Base.reverse(cscheme::ColorScheme) =
    ColorScheme(reverse(cscheme.colors), cscheme.category, cscheme.notes)

"""
    *(cscheme1, cscheme2)
    cscheme1 * cscheme2

Create new colorscheme by concatenating two colorschemes.
"""
*(cscheme1::ColorScheme, cscheme2::ColorScheme) = ColorScheme(vcat(cscheme1.colors, cscheme2.colors))

"""
    resample(cs::colorscheme, n=10)

Create a new colorscheme that samples an existing colorscheme `cs` `n` times.

```julia
resample(ColorSchemes.turbo)
resample(ColorSchemes.turbo, 5)
```
"""
function resample(cs::ColorScheme, n=10)
    return ColorScheme(
        [get(cs, i) for i in range(0, 1, length=max(n, 2))],
        cs.category,
        cs.notes * " resampled $n")
end

"""
    resample(cs::colorscheme, n, alphafunction)

Create a new colorscheme with RGBA colors that samples an existing colorscheme
`cs` `n` times and applies the single argument `alphafunction` at each sampling
point to set the alpha opacity value.

```julia
# set all 20 colors in scheme to alpha  0.5
resample(ColorSchemes.turbo, 20, (α) -> 0.5)

# set first 10 of 20 colors in scheme to alpha = 1
resample(ColorSchemes.turbo, 20, (alpha) -> alpha > 0.5 ? 1 : 0.0)

# set alpha value to sine; values around 0.5 are opaque 
resample(ColorSchemes.leonardo, 10, (alpha) -> sin(alpha * π))
```
"""
function resample(cs::ColorScheme, n, alpha::Function)
    return ColorScheme(
        [ColorSchemes.RGBA(get(cs, i), alpha(i)) for i in range(0, 1, length=max(n, 2))],
        cs.category,
        cs.notes * " resampled $n with alpha")
end

include("precompile.jl")

# Aliases - Oxford spelling       
const ColourScheme = ColorScheme
const colourschemes = colorschemes
const loadcolourscheme = loadcolorscheme
const findcolourscheme = findcolorscheme
const ColourSchemeCategory = ColorSchemeCategory

end

import PrecompileTools

PrecompileTools.@compile_workload begin
    get(ColorSchemes.leonardo, 0.5)
    get(ColorSchemes.leonardo, [0.0 1.0; -1.0 2.0])
    loadcolorscheme(:flag_blank, [
            RGB(1.1, 1.1, 1.1),
            RGB(1.1, 1.1, 1.1),
            RGB(1.1, 1.1, 1.1),
        ], "flags", "The flag of Blank")
end

using Test, Colors, ColorSchemes, ColorTypes, FixedPointNumbers

monalisa = ColorScheme([
    RGB(0.05482025926320272, 0.016508952654741622, 0.019315160361063788),
    RGB(0.07508160782698388, 0.034110215845969745, 0.039708343938094984),
    RGB(0.10884977211887092, 0.033667530751245296, 0.026120424375656533),
    RGB(0.10025110094110237, 0.05342427394738222, 0.04975936729231899),
    RGB(0.11004568002009293, 0.06764950003139521, 0.07202128202310687),
    RGB(0.1520114897984492, 0.06721701384356317, 0.04758612657624729),
    RGB(0.16121466572057147, 0.10737190368841328, 0.07491505937992286),
    RGB(0.2272468746270438, 0.09450818887496519, 0.053122482545649836),
    RGB(0.24275776450376843, 0.14465569383748178, 0.09254885719488251),
    RGB(0.19832488479851235, 0.16827798680930195, 0.08146721610879516),
    RGB(0.29030547394827216, 0.1566704731433784, 0.06955958896758961),
    RGB(0.3486958875330028, 0.14413808439049522, 0.06517845643634491),
    RGB(0.2631529920611145, 0.22896210929698424, 0.1119250237167965),
    RGB(0.35775151767110114, 0.23955578484799914, 0.08566681526152695),
    RGB(0.42895506355552904, 0.19814294026377038, 0.07315576139822164),
    RGB(0.3359280058835734, 0.30177882691623686, 0.14764230985832),
    RGB(0.5168174153887967, 0.2588008525490645, 0.07751817567374263),
    RGB(0.44056726473192726, 0.3387984774995975, 0.10490250831857457),
    RGB(0.4048595970607235, 0.40823989479512734, 0.2096109034699151),
    RGB(0.619694338941659, 0.33787470822764315, 0.0871136546089913),
    RGB(0.5108290351302369, 0.41506713362977327, 0.13590312315603137),
    RGB(0.5272516131642648, 0.4706039514608196, 0.21392546020040532),
    RGB(0.5942622209175139, 0.47822315473126586, 0.14678522310513448),
    RGB(0.735266714513005, 0.4318652289706696, 0.1049661472744881),
    RGB(0.6201870982552801, 0.5227924127640037, 0.2167074150596878),
    RGB(0.6929049533440698, 0.5663098519207086, 0.18551505068207655),
    RGB(0.6814114992549445, 0.5814898147520997, 0.27039081549715527),
    RGB(0.8500397772474145, 0.5401215248181611, 0.1362117676724628),
    RGB(0.7575520588269891, 0.6334254649343621, 0.25145144950124687),
    RGB(0.8164723313500291, 0.6970150665478066, 0.32242062463720045),
    RGB(0.9330273170314637, 0.6651641943114455, 0.19865164906805746),
    RGB(0.9724409077178674, 0.7907008712807734, 0.2851364857083522)],
    "testing",
    "colors from Leonardo da Vinci's Mona Lisa")

@testset "basic tests" begin
    @test length(monalisa) == 32
    @test length(monalisa.colors) == 32
    # test that sampling schemes yield different values
    @inferred get(monalisa, 0.0)
    @test get(monalisa, 0.0) != get(monalisa, 0.5)
    @test monalisa[end] ≈ monalisa[1.0]
    
    # indexing tests
    #=
    @test monalisa[begin] == first(monalisa) 
    TODO uncomment this test once ColorSchemes drops support for Julia versions <= 1.3.
    Use of "begin" in arrays is only supported in later versions of Julia, and throws 
    ERROR: LoadError: syntax: unexpected "]" (revealed through CI testing) in Julia 1.3.
    =#
    @test monalisa[1] == first(monalisa)
    @test monalisa[end] == last(monalisa)
end

# getinverse() tests are now in ColorSchemes

@testset "conversion tests" begin
    # convert an Array{T,2} to an RGB image
    tmp = @inferred get(monalisa, rand(10, 10))
    @test typeof(tmp) == Array{ColorTypes.RGB{Float64}, 2}

    # test conversion with default clamp
    x = [0.0 1.0 ; -1.0 2.0]
    y = @inferred get(monalisa, x)
    @test y[1,1] ≈ y[2,1]
    @test y[1,2] ≈ y[2,2]

    # test conversion with symbol clamp
    y2 = @inferred get(monalisa, x, :clamp)

    @test y2[1] ≈ y[1]
    @test y2[2] ≈ y[2]
    @test y2[end] ≈ y[end]

    # test conversion with symbol extrema
    y2 = @inferred get(monalisa, x, :extrema)
    @test y2[2,1] ≈ y[1, 1]   # Minimum now becomes one edge of ColorScheme
    @test y2[2,2] ≈ y[1, 2]   # Maximum now becomes other edge of ColorScheme
    @test y2[1,1] !== y2[2, 1] # Inbetween values or now different

    # test conversion with manually supplied range
    y3 = @inferred get(monalisa, x, (-1.0, 2.0))
    @test y3[1] ≈ y2[1]
    @test y3[2] ≈ y2[2]
    @test y3[end] ≈ y2[end]

    # test empty range (#43)
    y4 = @inferred get(monalisa, 0.4, (0.0, 0.0))
    @test 0.3 < y4.r < 0.4
    @test 0.2 < y4.g < 0.25
    @test 0.1 < y4.b < 0.15

    # test gray value (#23)
    c = @inferred get(monalisa, Gray(N0f16(1.0)))
    @test typeof(c) == RGB{Float64}
    @test c.r > 0.95
    @test c.g > 0.75
    @test c.b < 0.3
    c = @inferred get(monalisa, Gray24(N0f16(1.0)))
    @test typeof(c) == RGB{Float64}
    @test c.r > 0.95
    # Booleans
    @inferred get(monalisa, false)

    @test get(monalisa, 0.0) ≈  get(monalisa, false)
    @test get(monalisa, 1.0) ≈ get(monalisa, true)
end

@testset "misc tests" begin
    # test with steplen (#17)
    r  = range(0, stop=5, length=10)
    y  = @inferred get(monalisa, r)
    y2 = @inferred get(monalisa, collect(r))

    @test isapprox(y[1], y2[1]) # fixes #61

    # test for specific value
    val = 0.2
    y   = @inferred get(monalisa, [val])
    y2  = @inferred get(monalisa, val)
    @test isapprox(y[1], y2)

    col = @inferred get(reverse(monalisa), 0.0)
    @test col.r > 0.9
    @test col.g > 0.7
    @test col.b > 0.2

    # test iteration of a colorscheme
    counter = 1
    for (n, i) in enumerate(monalisa)
        @test counter == n
        counter += 1
    end
    @test counter == 33

    # test findcolorschemes()
    @test length(findcolorscheme("rainbow")) > 0

    # test resample
    csa = resample(ColorSchemes.turbo, 20)
    @test length(csa) == 20

    csa = resample(ColorSchemes.turbo, 20, (α) -> 0.5)
    @test csa[1].alpha == 0.5
end

# these won't error but they don't yet work correctly either
# until `get()` can handle nono-normalized color values
@testset "tests with 255-based scheme" begin
    monalisa1 = deepcopy(monalisa)
    # set all colors to 255
    for c in eachindex(monalisa1.colors)
        monalisa1.colors[c] = RGB(monalisa1.colors[c].r * 255, monalisa1.colors[c].g * 255, monalisa1.colors[c].b * 255)
    end
    @test length(monalisa1) ≈ 32
    @test length(monalisa1.colors) ≈ 32

    @test 12 < monalisa1[1].r < 14
    @test 3  < monalisa1[1].g < 5
    @test 3  < monalisa1[1].b < 6

    # test that sampling schemes yield different values
    @inferred get(monalisa1, 0.0)
    @test get(monalisa1, 0.0) != get(monalisa1, 0.5)
    @test monalisa1[end] ≈ monalisa1[1.0]
    tmp = @inferred get(monalisa1, rand(10, 10))
    @test typeof(tmp) == Array{ColorTypes.RGB{Float64}, 2}

    # test conversion with default clamp
    x = [0.0 1.0 ; -1.0 2.0]
    y = @inferred get(monalisa1, x)
    @test y[1,1] ≈ y[2,1]
    @test y[1,2] ≈ y[2,2]

    # test conversion with symbol clamp
    y2 = @inferred get(monalisa1, x, :clamp)

    @test isapprox(y2[1], y[1])
    @test isapprox(y2[2], y[2])
    @test isapprox(y2[end], y[end])

    # test conversion with symbol centered
    y2 = @inferred get(monalisa1, x, :centered)
    @test y2[2,2] ≈ y[1, 2]   # Maximum now becomes one edge of ColorScheme
    @test y2[1,1] ≈ get(monalisa1, 0.5) # Zero value is centered
    @test y2[1,2] ≈ get(monalisa1, 0.75)
    @test y2[2,1] ≈ get(monalisa1, 0.25)

    # test conversion with symbol extrema
    y2 = @inferred get(monalisa1, x, :extrema)
    @test y2[2,1] ≈ y[1, 1]   # Minimum now becomes one edge of ColorScheme
    @test y2[2,2] ≈ y[1, 2]   # Maximum now becomes other edge of ColorScheme
    @test y2[1,1] !== y2[2, 1] # Inbetween values now different

    # test conversion with manually supplied range
    y3 = @inferred get(monalisa1, x, (-1.0, 2.0))
    @test isapprox(y3[1], y2[1])
    @test isapprox(y3[2], y2[2])
    @test isapprox(y3[end], y2[end])

    # test error on unknown rangescale
    @test_throws ArgumentError get(monalisa1, x, :foo)

    # tests concatenation
    l1 = length(monalisa)
    l2 = length(monalisa * monalisa)
    @test l2 == 2l1
end

# MetBrewer
# Blake Robert Mills
# https://github.com/BlakeRMills/MetBrewer
# Palettes inspired by works at the Metropolitan Museum of Art
# in New York. All pieces selected come from various time
# periods, regions, and mediums.

loadcolorscheme(
    :Archambault,
    [
        colorant"#88a0dc",
        colorant"#381a61",
        colorant"#7c4b73",
        colorant"#ed968c",
        colorant"#ab3329",
        colorant"#e78429",
        colorant"#f9d14a",
    ],
    "MetBrewer",
    "Woman’s Dress and Accessories, 2005, Jodi Archambault, Hunkpapa Lakota (Teton Sioux), cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Austria,
    [
        colorant"#a40000",
        colorant"#16317d",
        colorant"#007e2f",
        colorant"#ffcd12",
        colorant"#b86092",
        colorant"#721b3e",
        colorant"#00b7a7",
    ],
    "MetBrewer",
    "Adoration of the Magi from Seven Scenes from the Life of Christ, 1390, Artists Unknown, Austrian",
)

loadcolorscheme(
    :Benedictus,
    [
        colorant"#9a133d",
        colorant"#b93961",
        colorant"#d8527c",
        colorant"#f28aaa",
        colorant"#f9b4c9",
        colorant"#f9e0e8",
        colorant"#ffffff",
        colorant"#eaf3ff",
        colorant"#c5daf6",
        colorant"#a1c2ed",
        colorant"#6996e3",
        colorant"#4060c8",
        colorant"#1a318b",
    ],
    "MetBrewer",
    "Relais, 1930 : quinze planches donnant quarante-deux motifs décoratifs : enluminure d'art de J. Saudé : préliminaires de Y. Rambosson, 1930, Edouard Bénedictus, French",
)

loadcolorscheme(
    :Cassatt1,
    [
        colorant"#b1615c",
        colorant"#d88782",
        colorant"#e3aba7",
        colorant"#edd7d9",
        colorant"#c9c9dd",
        colorant"#9d9dc7",
        colorant"#8282aa",
        colorant"#5a5a83",
    ],
    "MetBrewer",
    "The Cup of Tea, 1880-1881, Mary Cassatt, American, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Cassatt2,
    [
        colorant"#2d223c",
        colorant"#574571",
        colorant"#90719f",
        colorant"#b695bc",
        colorant"#dec5da",
        colorant"#c1d1aa",
        colorant"#7fa074",
        colorant"#466c4b",
        colorant"#2c4b27",
        colorant"#0e2810",
    ],
    "MetBrewer",
    "Lilacs in a Window (Vase de Lilas a la Fenetre), 1880–83, Mary Cassatt, American, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Cross,
    [
        colorant"#c969a1",
        colorant"#ce4441",
        colorant"#ee8577",
        colorant"#eb7926",
        colorant"#ffbb44",
        colorant"#859b6c",
        colorant"#62929a",
        colorant"#004f63",
        colorant"#122451",
    ],
    "MetBrewer",
    "Cap Nègre, 1909, Henri-Edmond Cross, French",
)

loadcolorscheme(
    :Degas,
    [
        colorant"#591d06",
        colorant"#96410e",
        colorant"#e5a335",
        colorant"#556219",
        colorant"#418979",
        colorant"#2b614e",
        colorant"#053c29",
    ],
    "MetBrewer",
    "The Rehearsal of the Ballet Onstage, 1874, Edgar Degas, French",
)

loadcolorscheme(
    :Demuth,
    [
        colorant"#591c19",
        colorant"#9b332b",
        colorant"#b64f32",
        colorant"#d39a2d",
        colorant"#f7c267",
        colorant"#b9b9b8",
        colorant"#8b8b99",
        colorant"#5d6174",
        colorant"#41485f",
        colorant"#262d42",
    ],
    "MetBrewer",
    "I Saw the Figure 5 in Gold, 1928, Charles Demuth, American, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Derain,
    [
        colorant"#efc86e",
        colorant"#97c684",
        colorant"#6f9969",
        colorant"#aab5d5",
        colorant"#808fe1",
        colorant"#5c66a8",
        colorant"#454a74",
    ],
    "MetBrewer",
    "The Palace of Westminster, 1906–1907, André Derain, French, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Egypt,
    [colorant"#dd5129", colorant"#0f7ba2", colorant"#43b284", colorant"#fab255"],
    "MetBrewer",
    "The King with Isis, Tomb of Haremhab, A.D. 1910–1911; original ca. 1323–1295 B.C., Twentieth Century; original New Kingdom, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Gauguin,
    [
        colorant"#b04948",
        colorant"#811e18",
        colorant"#9e4013",
        colorant"#c88a2c",
        colorant"#4c6216",
        colorant"#1a472a",
    ],
    "MetBrewer",
    "A Farm in Brittany, 1874, Paul Gauguin, French",
)

loadcolorscheme(
    :Greek,
    [
        colorant"#3c0d03",
        colorant"#8d1c06",
        colorant"#e67424",
        colorant"#ed9b49",
        colorant"#f5c34d",
    ],
    "MetBrewer",
    "Terracotta neck-amphora (jar), ca. 550–540 B.C., Greek, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Hiroshige,
    [
        colorant"#e76254",
        colorant"#ef8a47",
        colorant"#f7aa58",
        colorant"#ffd06f",
        colorant"#ffe6b7",
        colorant"#aadce0",
        colorant"#72bcd5",
        colorant"#528fad",
        colorant"#376795",
        colorant"#1e466e",
    ],
    "MetBrewer",
    "Sailing Boats Returning to Yabase, Lake Biwa, 1835, Utagawa Hiroshige, Japanese, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Hokusai1,
    [
        colorant"#6d2f20",
        colorant"#b75347",
        colorant"#df7e66",
        colorant"#e09351",
        colorant"#edc775",
        colorant"#94b594",
        colorant"#224b5e",
    ],
    "MetBrewer",
    "Poem by Gon-Chūnagon Sadaie, from the series One Hundred Poems Explained by the Nurse (Hyakunin isshu uba ga etoki), 1760–1849, Katsushika Hokusai, Japanese",
)

loadcolorscheme(
    :Hokusai2,
    [
        colorant"#abc9c8",
        colorant"#72aeb6",
        colorant"#4692b0",
        colorant"#2f70a1",
        colorant"#134b73",
        colorant"#0a3351",
    ],
    "MetBrewer",
    "Lake Suwa in Shinano Province (Shinshū Suwako), from the series Thirty-six Views of Mount Fuji (Fugaku sanjūrokkei), 1830-32, Katsushika Hokusai, Japanese, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Hokusai3,
    [
        colorant"#d8d97a",
        colorant"#95c36e",
        colorant"#74c8c3",
        colorant"#5a97c1",
        colorant"#295384",
        colorant"#0a2e57",
    ],
    "MetBrewer",
    "Yōrō Waterfall in Mino Province (Mino no Yōrō no taki), from the series A Tour of Waterfalls in Various Provinces (Shokoku taki meguri), 1832, Katsushika Hokusai, Japanese, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Homer1,
    [
        colorant"#551f00",
        colorant"#a62f00",
        colorant"#df7700",
        colorant"#f5b642",
        colorant"#fff179",
        colorant"#c3f4f6",
        colorant"#6ad5e8",
        colorant"#32b2da",
    ],
    "MetBrewer",
    "The Veteran in a New Field, 1865, Winslow Homer, American",
)

loadcolorscheme(
    :Homer2,
    [
        colorant"#bf3626",
        colorant"#e9724c",
        colorant"#e9851d",
        colorant"#f9c53b",
        colorant"#aeac4c",
        colorant"#788f33",
        colorant"#165d43",
    ],
    "MetBrewer",
    "Flower Garden and Bungalow, Bermuda, 1899, Winslow Homer, American",
)

loadcolorscheme(
    :Ingres,
    [
        colorant"#041d2c",
        colorant"#06314e",
        colorant"#18527e",
        colorant"#2e77ab",
        colorant"#d1b252",
        colorant"#a97f2f",
        colorant"#7e5522",
        colorant"#472c0b",
    ],
    "MetBrewer",
    "Joséphine-Éléonore-Marie-Pauline de Galard de Brassac de Béarn (1825–1860), Princesse de Broglie, 1851–53, Jean Auguste Dominique Ingres, French, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Isfahan1,
    [
        colorant"#4e3910",
        colorant"#845d29",
        colorant"#d8c29d",
        colorant"#4fb6ca",
        colorant"#178f92",
        colorant"#175f5d",
        colorant"#1d1f54",
    ],
    "MetBrewer",
    "Mihrab (Prayer Niche), dated A.H. 755/ A.D. 1354–55, From Iran, Isfahan, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Isfahan2,
    [
        colorant"#d7aca1",
        colorant"#ddc000",
        colorant"#79ad41",
        colorant"#34b6c6",
        colorant"#4063a3",
    ],
    "MetBrewer",
    "Garden Gathering, 1640–50, From Iran, Isfahan, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Java,
    [
        colorant"#663171",
        colorant"#cf3a36",
        colorant"#ea7428",
        colorant"#e2998a",
        colorant"#0c7156",
    ],
    "MetBrewer",
    "Skirt, 20th Century, Javanese People, Javanese, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Johnson,
    [
        colorant"#a00e00",
        colorant"#d04e00",
        colorant"#f6c200",
        colorant"#0086a8",
        colorant"#132b69",
    ],
    "MetBrewer",
    "Jitterbugs V, 1941–42, William Henry Johnson, American, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Juarez,
    [
        colorant"#a82203",
        colorant"#208cc0",
        colorant"#f1af3a",
        colorant"#cf5e4e",
        colorant"#637b31",
        colorant"#003967",
    ],
    "MetBrewer",
    "The Entombment of Christ, 1702, Juan Rodríguez Juárez, Mexican",
)

loadcolorscheme(
    :Kandinsky,
    [colorant"#3b7c70", colorant"#ce9642", colorant"#898e9f", colorant"#3b3a3e"],
    "MetBrewer",
    "Kleine Welten IV (Small Worlds IV), 1922, Vasily Kandinsky, French, born Russia, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Klimt,
    [
        colorant"#df9ed4",
        colorant"#c93f55",
        colorant"#eacc62",
        colorant"#469d76",
        colorant"#3c4b99",
        colorant"#924099",
    ],
    "MetBrewer",
    "Mäda Primavesi (1903–2000), 1912-13, Gustav Klimt, Austria",
)

loadcolorscheme(
    :Lakota,
    [
        colorant"#04a3bd",
        colorant"#f0be3d",
        colorant"#931e18",
        colorant"#da7901",
        colorant"#247d3f",
        colorant"#20235b",
    ],
    "MetBrewer",
    "Dress, 1870, Lakota/Teton Sioux, Native American",
)

loadcolorscheme(
    :Manet,
    [
        colorant"#3b2319",
        colorant"#80521c",
        colorant"#d29c44",
        colorant"#ebc174",
        colorant"#ede2cc",
        colorant"#7ec5f4",
        colorant"#4585b7",
        colorant"#225e92",
        colorant"#183571",
        colorant"#43429b",
        colorant"#5e65be",
    ],
    "MetBrewer",
    "Boating, 1874, Edouard Manet, French",
)

loadcolorscheme(
    :Monet,
    [
        colorant"#4e6d58",
        colorant"#749e89",
        colorant"#abccbe",
        colorant"#e3cacf",
        colorant"#c399a2",
        colorant"#9f6e71",
        colorant"#41507b",
        colorant"#7d87b2",
        colorant"#c2cae3",
    ],
    "MetBrewer",
    "Bridge over a Pond of Water Lilies, 1899, Claude Monet, French",
)

loadcolorscheme(
    :Moreau,
    [
        colorant"#421600",
        colorant"#792504",
        colorant"#bc7524",
        colorant"#8dadca",
        colorant"#527baa",
        colorant"#104839",
        colorant"#082844",
    ],
    "MetBrewer",
    "Oedipus and the Sphinx, 1864, Gustave Moreau, French",
)

loadcolorscheme(
    :Morgenstern,
    [
        colorant"#7c668c",
        colorant"#b08ba5",
        colorant"#dfbbc8",
        colorant"#ffc680",
        colorant"#ffb178",
        colorant"#db8872",
        colorant"#a56457",
    ],
    "MetBrewer",
    "Jungfrau, Mönch, and Eiger, 1851, Carl Morgenstern, German, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Nattier,
    [
        colorant"#52271c",
        colorant"#944839",
        colorant"#c08e39",
        colorant"#7f793c",
        colorant"#565c33",
        colorant"#184948",
        colorant"#022a2a",
    ],
    "MetBrewer",
    "Madame Bergeret de Frouville as Diana, 1756, Jean Marc Nattier, French",
)

loadcolorscheme(
    :Navajo,
    [
        colorant"#660d20",
        colorant"#e59a52",
        colorant"#edce79",
        colorant"#094568",
        colorant"#e1c59a",
    ],
    "MetBrewer",
    "Serape, 1865–70, Navajo",
)

loadcolorscheme(
    :NewKingdom,
    [
        colorant"#e1846c",
        colorant"#9eb4e0",
        colorant"#e6bb9e",
        colorant"#9c6849",
        colorant"#735852",
    ],
    "MetBrewer",
    "Blue-Painted Ibex Amphora from Malqata, ca. 1390–1353 B.C., New Kingdom",
)

loadcolorscheme(
    :Nizami,
    [
        colorant"#dd7867",
        colorant"#b83326",
        colorant"#c8570d",
        colorant"#edb144",
        colorant"#8cc8bc",
        colorant"#7da7ea",
        colorant"#5773c0",
        colorant"#1d4497",
    ],
    "MetBrewer",
    "\"Laila and Majnun in School\", Folio 129 from a Khamsa (Quintet) of Nizami of Ganja, A.H. 931/A.D. 1524–25, Nizami, Made in present-day Afghanistan, Herat",
)

loadcolorscheme(
    :OKeeffe1,
    [
        colorant"#6b200c",
        colorant"#973d21",
        colorant"#da6c42",
        colorant"#ee956a",
        colorant"#fbc2a9",
        colorant"#f6f2ee",
        colorant"#bad6f9",
        colorant"#7db0ea",
        colorant"#447fdd",
        colorant"#225bb2",
        colorant"#133e7e",
    ],
    "MetBrewer",
    "From the Faraway, Nearby, 1937, Georgia O'Keeffe, American, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :OKeeffe2,
    [
        colorant"#fbe3c2",
        colorant"#f2c88f",
        colorant"#ecb27d",
        colorant"#e69c6b",
        colorant"#d37750",
        colorant"#b9563f",
        colorant"#92351e",
    ],
    "MetBrewer",
    "Red and Yellow Cliffs, 1940, Georgia O'Keeffe, American, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Paquin,
    [
        colorant"#831818",
        colorant"#c62320",
        colorant"#f05b43",
        colorant"#f78462",
        colorant"#feac81",
        colorant"#f7dea3",
        colorant"#ced1af",
        colorant"#98ab76",
        colorant"#748f46",
        colorant"#47632a",
        colorant"#275024",
    ],
    "MetBrewer",
    "Evening Dress, 1937, House of Paquin by Ana de Pombo, French House, Spanish Designer",
)

loadcolorscheme(
    :Peru1,
    [
        colorant"#b5361c",
        colorant"#e35e28",
        colorant"#1c9d7c",
        colorant"#31c7ba",
        colorant"#369cc9",
        colorant"#3a507f",
    ],
    "MetBrewer",
    "Ear Ornament, Winged Runner, A.D. 400–700, Moche, Peruvian",
)

loadcolorscheme(
    :Peru2,
    [
        colorant"#65150b",
        colorant"#961f1f",
        colorant"#c0431f",
        colorant"#b36c06",
        colorant"#f19425",
        colorant"#c59349",
        colorant"#533d14",
    ],
    "MetBrewer",
    "Tunic with Confronting Catfish, A.D. 800–850, Nasca-Wari, Peruvian",
)

loadcolorscheme(
    :Pillement,
    [
        colorant"#a9845b",
        colorant"#697852",
        colorant"#738e8e",
        colorant"#44636f",
        colorant"#2b4655",
        colorant"#0f252f",
    ],
    "MetBrewer",
    "A Shipwreck in a Storm, 1782, Jean Pillement, French, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Pissaro,
    [
        colorant"#134130",
        colorant"#4c825d",
        colorant"#8cae9e",
        colorant"#8dc7dc",
        colorant"#508ca7",
        colorant"#1a5270",
        colorant"#0e2a4d",
    ],
    "MetBrewer",
    "Washerwoman, Study, 1880, Camille Pissarro, French",
)

loadcolorscheme(
    :Redon,
    [
        colorant"#5b859e",
        colorant"#1e395f",
        colorant"#75884b",
        colorant"#1e5a46",
        colorant"#df8d71",
        colorant"#af4f2f",
        colorant"#d48f90",
        colorant"#732f30",
        colorant"#ab84a5",
        colorant"#59385c",
        colorant"#d8b847",
        colorant"#b38711",
    ],
    "MetBrewer",
    "Pandora, 1914, Odilon Redon, French",
)

loadcolorscheme(
    :Renoir,
    [
        colorant"#17154f",
        colorant"#2f357c",
        colorant"#6c5d9e",
        colorant"#9d9cd5",
        colorant"#b0799a",
        colorant"#f6b3b0",
        colorant"#e48171",
        colorant"#bf3729",
        colorant"#e69b00",
        colorant"#f5bb50",
        colorant"#ada43b",
        colorant"#355828",
    ],
    "MetBrewer",
    "Nini in the Garden (Nini Lopez), 1876, Auguste Renoir, French",
)

loadcolorscheme(
    :Robert,
    [
        colorant"#11341a",
        colorant"#375624",
        colorant"#6ca4a0",
        colorant"#487a7c",
        colorant"#18505f",
        colorant"#062e3d",
    ],
    "MetBrewer",
    "The Bathing Pool, Hubert Robert, French",
)

loadcolorscheme(
    :Signac,
    [
        colorant"#fbe183",
        colorant"#f4c40f",
        colorant"#fe9b00",
        colorant"#d8443c",
        colorant"#9b3441",
        colorant"#de597c",
        colorant"#e87b89",
        colorant"#e6a2a6",
        colorant"#aa7aa1",
        colorant"#9f5691",
        colorant"#633372",
        colorant"#1f6e9c",
        colorant"#2b9b81",
        colorant"#92c051",
    ],
    "MetBrewer",
    "Notre-Dame-de-la-Garde (La Bonne-Mère), Marseilles, 1905-06, Paul Signac, French",
)

loadcolorscheme(
    :Stevens,
    [
        colorant"#042e4e",
        colorant"#307d7f",
        colorant"#598c4c",
        colorant"#ba5c3f",
        colorant"#a13213",
        colorant"#470c00",
    ],
    "MetBrewer",
    "The Japanese Robe, 1872, Alfred Stevens, Belgian",
)

loadcolorscheme(
    :Tam,
    [
        colorant"#ffd353",
        colorant"#ffb242",
        colorant"#ef8737",
        colorant"#de4f33",
        colorant"#bb292c",
        colorant"#9f2d55",
        colorant"#62205f",
        colorant"#341648",
    ],
    "MetBrewer",
    "Dragon Robe, 1998, Vivienne Tam, American, born China, cvd friendly, color blind friendly",
)


loadcolorscheme(
    :Tara,
    [
        colorant"#eab1c6",
        colorant"#d35e17",
        colorant"#e18a1f",
        colorant"#e9b109",
        colorant"#829d44",
    ],
    "MetBrewer",
    "Maharana Sarup Singh Inspects a Prize Stallion, 1845–46, Tara, Western India, Rajasthan, Mewar",
)

loadcolorscheme(
    :Thomas,
    [
        colorant"#b24422",
        colorant"#c44d76",
        colorant"#4457a5",
        colorant"#13315f",
        colorant"#b1a1cc",
        colorant"#59386c",
        colorant"#447861",
        colorant"#7caf5c",
    ],
    "MetBrewer",
    "Formes et couleurs: vingt planches en couleurs contenant soixante-sept motifs decoratifs, 1921, Auguste H. Thomas, French",
)

loadcolorscheme(
    :Tiepolo,
    [
        colorant"#802417",
        colorant"#c06636",
        colorant"#ce9344",
        colorant"#e8b960",
        colorant"#646e3b",
        colorant"#2b5851",
        colorant"#508ea2",
        colorant"#17486f",
    ],
    "MetBrewer",
    "The Glorification of the Barbaro Family, 1750, Giovanni Battista Tiepolo, Italian",
)

loadcolorscheme(
    :Troy,
    [
        colorant"#421401",
        colorant"#6c1d0e",
        colorant"#8b3a2b",
        colorant"#c27668",
        colorant"#7ba0b4",
        colorant"#44728c",
        colorant"#235070",
        colorant"#0a2d46",
    ],
    "MetBrewer",
    "The Declaration of Love, 1724, Jean François de Troy, French, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Tsimshian,
    [
        colorant"#582310",
        colorant"#aa361d",
        colorant"#82c45f",
        colorant"#318f49",
        colorant"#0cb4bb",
        colorant"#2673a3",
        colorant"#473d7d",
    ],
    "MetBrewer",
    "Headdress frontlet, 1820–40, Tsimshian, Native American (Canadian)",
)

loadcolorscheme(
    :VanGogh1,
    [
        colorant"#2c2d54",
        colorant"#434475",
        colorant"#6b6ca3",
        colorant"#969bc7",
        colorant"#87bcbd",
        colorant"#89ab7c",
        colorant"#6f9954",
    ],
    "MetBrewer",
    "Cypresses, 1889, Vincent van Gogh, Dutch",
)

loadcolorscheme(
    :VanGogh2,
    [
        colorant"#bd3106",
        colorant"#d9700e",
        colorant"#e9a00e",
        colorant"#eebe04",
        colorant"#5b7314",
        colorant"#c3d6ce",
        colorant"#89a6bb",
        colorant"#454b87",
    ],
    "MetBrewer",
    "Self-Portrait with a Straw Hat (obverse: The Potato Peeler), 1887, Vincent van Gogh, Dutch",
)

loadcolorscheme(
    :VanGogh3,
    [
        colorant"#e7e5cc",
        colorant"#c2d6a4",
        colorant"#9cc184",
        colorant"#669d62",
        colorant"#447243",
        colorant"#1f5b25",
        colorant"#1e3d14",
        colorant"#192813",
    ],
    "MetBrewer",
    "First Steps, after Millet, 1890, Vincent van Gogh, Dutch, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Veronese,
    [
        colorant"#67322e",
        colorant"#99610a",
        colorant"#c38f16",
        colorant"#6e948c",
        colorant"#2c6b67",
        colorant"#175449",
        colorant"#122c43",
    ],
    "MetBrewer",
    "Mars and Venus United by Love, 1570s, Paolo Veronese, Italian, cvd friendly, color blind friendly",
)

loadcolorscheme(
    :Wissing,
    [
        colorant"#4b1d0d",
        colorant"#7c291e",
        colorant"#ba7233",
        colorant"#3a4421",
        colorant"#2d5380",
    ],
    "MetBrewer",
    "Portrait of a Woman, 1687, Willem Wissing, Dutch",
)

loadcolorscheme(:julia, [
    colorant"#1f83ff", # blue
    colorant"#CA3C32", # red
    colorant"#399746", # green
    colorant"#9259A3", # purple
], "julia", "sequential")


# Colors from first logo
loadcolorscheme(:julialegacy, [
    colorant"#6a82e0", # blue
    colorant"#d8645f", # red
    colorant"#69ad57", # green
    colorant"#ab7ac1", # purple
    ], "julia", "sequential. The Julia logo was duo-tone (with both light and dark versions of the four colors) from 2010 up to 2019, release v1.2. Since then, only the darker colors are used.")

loadcolorscheme(:jblue, [
    colorant"#d2e6ff",
    colorant"#a5cdff",
    colorant"#79b5ff",
    colorant"#4c9cff",
    colorant"#1f83ff",
    colorant"#1969cc",
    colorant"#134f99",
    colorant"#0c3466",
    colorant"#061a33",
], "julia", "sequential")

loadcolorscheme(:jred, [
    colorant"#f4d8d6",
    colorant"#eab1ad",
    colorant"#df8a84",
    colorant"#d5635b",
    colorant"#ca3c32",
    colorant"#a23028",
    colorant"#79241e",
    colorant"#511814",
    colorant"#280c0a",
], "julia", "sequential")

loadcolorscheme(:jgreen, [
    colorant"#d7eada",
    colorant"#b0d5b5",
    colorant"#88c190",
    colorant"#61ac6b",
    colorant"#399746",
    colorant"#2e7938",
    colorant"#225b2a",
    colorant"#173c1c",
    colorant"#0b1e0e",
], "julia", "sequential")

loadcolorscheme(:jredgreen, [
    colorant"#ca3c32",
    colorant"#d5635b",
    colorant"#df8a84",
    colorant"#eab1ad",
    colorant"#f4d8d6",
    colorant"#f9fafb",
    colorant"#d7eada",
    colorant"#b0d5b5",
    colorant"#88c190",
    colorant"#61ac6b",
    colorant"#399746",
], "julia", "diverging")

loadcolorscheme(:jpurple, [
    colorant"#e9deed",
    colorant"#d3bdda",
    colorant"#be9bc8",
    colorant"#a87ab5",
    colorant"#9259a3",
    colorant"#754782",
    colorant"#583562",
    colorant"#3a2441",
    colorant"#1d1221",
], "julia", "sequential")

# Plotting

## UnicodePlots.jl

The `heatmap()` function in [UnicodePlots.jl](https://github.com/Evizero/UnicodePlots.jl) can use colorschemes. You have to supply the colors as an array of floating-point numbers first:

```julia
... colormap = [(x.r, x.g, x.b) for x in ColorSchemes.leonardo.colors]
```

For example:

```julia
heatmap(z::AbstractMatrix; title = "Hot!",
    colormap = [(x.r, x.g, x.b) for x in ColorSchemes.leonardo.colors])
```

!["heatmap"](assets/figures/unicodeplots-heatmap.png)

## Plots.jl

[Plots.jl](https://docs.juliaplots.org/) supports all colorschemes from ColorSchemes.jl. They can be used as a gradient or as a palette and are passed as a symbol holding their name to `cgrad` or `palette`.

This renaissance-looking plot uses the `leonardo` scheme:

```julia
using Plots

x = 1:0.3:20
y = x
f(x, y) = begin
      sin(x) + cos(y)
  end
contour(x, y, f, fill=true, c = :leonardo)
```

!["contour"](assets/figures/plots-contour-1.png)

(You can use `c` as a short cut for `seriescolor`.)

With other plots, use the `palette` keyword:

```julia
using ColorSchemes

plot(Plots.fakedata(100, 20),
      w=4,
      background_color=ColorSchemes.vermeer[1],
      palette=:vermeer)
```

!["palette"](assets/figures/plots-background.png)

## Gadfly

Here's how you can use ColorSchemes in Gadfly:

```julia
using Gadfly, ColorSchemes
x = repeat(collect(1:20), inner=[20]);
y = repeat(collect(1:20), outer=[20]);
plot(x=x, y=y,
    color=x+y,
    Geom.rectbin,
    Scale.ContinuousColorScale(p -> get(ColorSchemes.sunset, p)))
```

!["gadfly"](assets/figures/gadfly-sunset.png)

## Makie

If you use Makie.jl you can pass the colors in a ColorScheme directly to the `colormap` keyword.

```julia
using Makie, ColorSchemes
N = 20
x = LinRange(-0.3, 1, N)
y = LinRange(-1, 0.5, N)
z = x .* y'
image(x, y, z, colormap = ColorSchemes.picasso.colors)
```

!["makie"](assets/figures/makie.png)

You can display all the colorschemes using Makie by letting the code browse through the `colorschemes` dictionary:

```julia
using Makie, ColorSchemes

h = 0.0
offset = 0.1
scene = Scene()
cam2d!(scene)
plot = map(collect(keys(colorschemes))) do cmap
     global h
     c = to_colormap(colorschemes[cmap].colors)
     cbar = image!(
         scene,
         range(0, stop = 10, length = length(c)),
         range(0, stop = 1, length = length(c)),
         reshape(c, (length(c), 1)),
         show_axis = false
     )[end]
     text!(
         scene,
         string(cmap, ":"),
         position = Point2f0(-0.1, 0.5 + h),
         align = (:right, :center),
         show_axis = false,
         textsize = 0.4
     )
     translate!(cbar, 0, h, 0)
     h -= (1 + offset)
end
scene
```

!["makie all colorschemes"](assets/figures/allschemesmakie.png)

## Winston

If you prefer Winston.jl for plotting, you can use ColorSchemes with `imagesc`:

```julia
using Winston, ColorSchemes
klimt = ColorSchemes.klimt.colors
Winston.colormap(klimt)
Winston.imagesc(reshape(1:10000,100,100))
```

!["winston klimt"](assets/figures/winston.png)

Sometimes you'll want a smoother gradient with more colors. You can use `get(scheme, n)` to generate a more detailed array of colors, varying `n` from 0 to 1 by 0.001:

```julia
brasstones = ColorSchemes.brass
brasstonesmooth = [get(brasstones, i) for i in 0:0.001:1]
Winston.colormap(brasstonesmooth)
Winston.imagesc(reshape(1:10000,100,100))
```

!["winston brass tones](assets/figures/winston1.png)

## PyPlot

ColorSchemes can be used with the `cmap` keyword in PyPlot:

```julia
using PyPlot, Distributions, ColorSchemes

solar = ColorSchemes.solar.colors

n = 100
x = range(-3, stop=3, length=n)
y = range(-3, stop=3, length=n)

xgrid = repeat(x', n, 1);
ygrid = repeat(y, 1, n);
z = zeros(n, n);

for i in 1:n
    for j in 1:n
        z[i, j] = 2sin(x[i]) * 2cos(y[j])
    end
end

fig = PyPlot.figure("pyplot_surfaceplot",figsize=(10,10))

using3D()
ax = fig.add_subplot(2, 1, 1, projection = "3d")

ax.plot_surface(xgrid, ygrid, z, rstride=2,edgecolors="k",
    cstride=2,
    cmap=ColorMap(solar),
    alpha=0.8,
    linewidth=0.25)

display(fig)
```

!["pyplot"](assets/figures/pyplot.png)

# Basics

## ColorScheme objects

When you start `using ColorSchemes`, it loads a set of pre-defined ColorSchemes in a dictionary called `colorschemes`.

A ColorScheme is a Julia object which contains:

- an ordered array of colors (see Colors.jl)
- a string defining a category
- a string containing descriptive notes

To access one of the built-in colorschemes, use its symbol:

```@example
using Colors, ColorSchemes # hide
ColorSchemes.leonardo 
```

or

```@example
using Colors, ColorSchemes # hide
colorschemes[:leonardo]
```

The display depends on your working environment. If you’re using a notebook or IDE environment, the colors in the colorscheme should appear as a swatch in a cell or in a Plots window. Otherwise, you’ll see the colors listed as RGB values:

```julia
32-element Array{RGB{Float64},1}:
 RGB{Float64}(0.0548203,0.016509,0.0193152)
 RGB{Float64}(0.0750816,0.0341102,0.0397083)
 RGB{Float64}(0.10885,0.0336675,0.0261204)
 RGB{Float64}(0.100251,0.0534243,0.0497594)
 ...
 RGB{Float64}(0.620187,0.522792,0.216707)
 RGB{Float64}(0.692905,0.56631,0.185515)
 RGB{Float64}(0.681411,0.58149,0.270391)
 RGB{Float64}(0.85004,0.540122,0.136212)
 RGB{Float64}(0.757552,0.633425,0.251451)
 RGB{Float64}(0.816472,0.697015,0.322421)
 RGB{Float64}(0.933027,0.665164,0.198652)
 RGB{Float64}(0.972441,0.790701,0.285136)
```

You can access the array of colors as:

```julia
ColorSchemes.leonardo.colors
```

By default, the names of the built-in colorschemes aren’t imported. You can import the ones that you want:

```julia
julia> import ColorSchemes.leonardo
julia> leonardo
32-element Array{RGB{Float64},1}:
 RGB{Float64}(0.0548203,0.016509,0.0193152)
 RGB{Float64}(0.0750816,0.0341102,0.0397083)
 RGB{Float64}(0.10885,0.0336675,0.0261204)
 RGB{Float64}(0.100251,0.0534243,0.0497594)
 ...
 RGB{Float64}(0.757552,0.633425,0.251451)
 RGB{Float64}(0.816472,0.697015,0.322421)
 RGB{Float64}(0.933027,0.665164,0.198652)
 RGB{Float64}(0.972441,0.790701,0.285136)
```

You can reference a single color in a scheme:

```julia
leonardo[3]

-> RGB{Float64}(0.10884977211887092,0.033667530751245296,0.026120424375656533)
```

Or you can ‘sample’ the scheme at any point between 0 and 1 using `get` or `getindex`:

```julia
get(leonardo, 0.5)

-> RGB{Float64}(0.42637271063618504,0.28028983973265065,0.11258024276603132)

leonardo[0.5]

-> RGB{Float64}(0.42637271063618504,0.28028983973265065,0.11258024276603132)
```

With `get` you can resample an existing colorscheme, by passing a range:

```julia
get(ColorSchemes.darkrainbow, range(0.0, 1.0, length=14))

-> RGB{Float64}[
      RGB{Float64}(0.237736, 0.340215, 0.575113), 
      RGB{Float64}(0.249978, 0.343813, 0.5620657), 
      RGB{Float64}(0.259452, 0.386963, 0.464862), 
      RGB{Float64}(0.272746, 0.439684, 0.3499807), 
      ...
      RGB{Float64}(0.72987,0.239399,0.230961), 
      RGB{Float64}(0.72987,0.239399,0.230961)]
```

and you can make a new scheme from this:

```@example
using ColorSchemes, Colors # hide
ndr = ColorScheme(get(ColorSchemes.darkrainbow, range(0.0, 1.0, length=14)))
```

See below for more possibilities.

## The colorschemes dictionary

The ColorSchemes module automatically provides a number of predefined schemes. All the colorschemes are stored in an exported dictionary, called `colorschemes`.

```julia
colorschemes[:summer] |> show
    ColorScheme(
        ColorTypes.RGB{Float64}[
            RGB{Float64}(0.0,0.5,0.4),
            RGB{Float64}(0.01,0.505,0.4),
            RGB{Float64}(0.02,0.51,0.4),
            RGB{Float64}(0.03,0.515,0.4),
            ...
            RGB{Float64}(1.0,1.0,0.4)],
       "matplotlib",
       "sampled color schemes, sequential linearly-increasing shades of green-yellow")
```

## Finding colorschemes

Use the [findcolorscheme](@ref) function to search through
the pre-defined colorschemes. The string you provide can
occur in the colorscheme’s name, in the category, or
(optionally) in the notes. It’s interpreted as a
case-insensitive regular expression.

```julia
julia> findcolorscheme("ice")

colorschemes containing "ice"

  seaborn_icefire_gradient
  seaborn_icefire_gradient  (notes) sequential, ice fire gradient...
  ice                 
  flag_is                   (notes) The flag of Iceland...
  botticelli          
  botticelli                (notes) palette from artist Sandro Bot...


 ...found 6 results for "ice"
```

The function returns a list of matching colorscheme names as symbols.

```@docs
findcolorscheme
```

If you prefer, you can ‘roll your own’ search.

```julia
[k for (k, v) in ColorSchemes.colorschemes if occursin(r"colorbrew"i, v.category)]
265-element Array{Symbol,1}:
 :BuPu_6
 :Spectral_4
 :RdYlGn_5
 ⋮
 :BrBG_8
 :Oranges_4
```

## Make your own colorscheme

Using Colors.jl, you can use the `ColorScheme` constructor to make a range of colors into a colorscheme.

Using Colors.jl's `range()`:

```@example
using Colors, ColorSchemes # hide
cs1 = ColorScheme(range(colorant"red", colorant"green", length=5))
```

Using `get()`:

```@example
using Colors, ColorSchemes # hide
cs1 = ColorScheme(get(ColorSchemes.darkrainbow, range(0.3, 0.7, length=10)))
```

Converting from a sequential palette:

```@example
using Colors, ColorSchemes # hide
cs1 = ColorScheme(reverse(Colors.sequential_palette(300, 100, logscale=true)))
```

From an array comprehension:

```@example
using Colors, ColorSchemes # hide
mygrays = ColorScheme([RGB{Float64}(i, i, i) for i in 0:0.1:1.0])
```

A logarithmic scheme:

```@example
using Colors, ColorSchemes # hide
ColorScheme(get(ColorSchemes.darkrainbow, 10 .^ range(-2, stop=0, length=50)))
```

Give it a category or some added notes if you want:

```julia
mygrays = ColorScheme([RGB{Float64}(i, i, i) for i in 0:0.1:1.0],
    "my useful schemes", "just some dull grey shades")
```

although this scheme won’t be stored in the supplied `colorschemes` dictionary.

Another example: start with a two-color scheme, then building a gradient from the first color to the other.

```julia
myscheme = ColorScheme([Colors.RGB(1.0, 0.0, 0.0), Colors.RGB(0.0, 1.0, 0.0)],
               "custom", "twotone, red and green")
ColorScheme([get(myscheme, i) for i in 0.0:0.01:1.0])
```

Another way is to use the [loadcolorscheme](@ref) function used to build the colorschemes dictionary when the package is loaded:

```julia
using Colors, ColorSchemes
loadcolorscheme(:mygrays, [RGB{Float64}(i, i, i) for i in 0:0.1:1.0],
     "useful schemes", "just some dull grey shades")
```

and that will be added (temporarily) to the built-in dictionary.

```julia
julia> findcolorscheme("dull")

colorschemes containing "dull"

  mygrays               (notes) just some dull grey shades...


 ...found 1 result for "dull"
```

!!! note

    If you want to make more advanced ColorSchemes, use linear-segment dictionaries or indexed lists, and use functions to generate color values, see the `make_colorscheme()` function in the [ColorSchemeTools.jl](https://github.com/JuliaGraphics/ColorSchemeTools.jl) package.

## For CVD (color-vision deficient or "color-blind") users

This package contains a number of colorschemes that are designed to be helpful for people with some deficiencies in their perception of color:

- *deuteranomaly* (where green looks more red)

- *protanomaly* (where red looks more green and less bright)

- *tritanomaly* (difficult to tell the difference between blue and green, and between yellow and red)

- *tritanopia* (difficult to tell the difference between blue and green, purple and red, and yellow and pink)

```julia
findcolorscheme("cvd")

colorschemes containing "cvd"

  tol_light            (category) cvd
  tol_muted            (category) cvd
  tol_bright           (category) cvd
  okabe_ito            (category) cvd
  mk_8                 (category) cvd
  mk_12                (category) cvd
  mk_15                (category) cvd
```

### :tol_light
```@example
using ColorSchemes # hide
ColorSchemes.tol_light # hide
```

### :tol_muted
```@example
using ColorSchemes # hide
ColorSchemes.tol_muted # hide
```

### :tol_bright
```@example
using ColorSchemes # hide
ColorSchemes.tol_bright # hide
```

### :okabe_ito
```@example
using ColorSchemes # hide
ColorSchemes.okabe_ito # hide
```

### :mk_8
```@example
using ColorSchemes # hide
ColorSchemes.mk_8 # hide
```

### :mk_12
```@example
using ColorSchemes # hide
ColorSchemes.mk_12 # hide
```

### :mk_15
```@example
using ColorSchemes # hide
ColorSchemes.mk_15 # hide
```

Also, it's possible to generate schemes using `Colors.distinguishable_colors()`:

```@example
using Colors, ColorSchemes
ColorScheme(distinguishable_colors(10, transform=protanopic))
```

## The `resample()` function

Use `resample()` to make a new colorscheme by resampling an existing one:

```@example
using Colors, ColorSchemes # hide
ColorSchemes.turbo
```
```@example
using Colors, ColorSchemes # hide
resample(ColorSchemes.turbo, 9) 
```

You can pass a function to `resample()` to control the alpha opacity of each color in the color scheme.

```@example
using Colors, ColorSchemes # hide
resample(ColorSchemes.turbo, 9, (alpha) -> 0.5) 
```

This sets the alpha value of every color to 0.5.

```@example
using Colors, ColorSchemes # hide
resample(ColorSchemes.turbo, 30, (alpha) -> sin(alpha * π)) 
```

This example varies the alpha from 0 (at 0.0), 1 (at 0.5), and 0 (at 1.0). 

## More about color sampling

You can access the specific colors of a colorscheme by indexing (eg `leonardo[2]` or `leonardo[5:end]`). Or you can sample a ColorScheme at a point between 0.0 and 1.0 as if it were a continuous range of colors:

```julia
get(leonardo, 0.5)
```

returns

```julia
RGB{Float64}(0.42637271063618504,0.28028983973265065,0.11258024276603132)
```

!["get example"](assets/figures/get-example.png)

The colors in the predefined ColorSchemes are usually sorted by LUV luminance, so this often makes sense.

You can use `get()` with index data in arrays to return arrays of colors:

```julia
julia> get(leonardo, [0.0, 0.5, 1.0])
3-element Array{RGB{Float64},1} with eltype ColorTypes.RGB{Float64}:
 RGB{Float64}(0.05482025926320272,0.016508952654741622,0.019315160361063788)
 RGB{Float64}(0.42637271063618504,0.28028983973265065,0.11258024276603132)  
 RGB{Float64}(0.9724409077178674,0.7907008712807734,0.2851364857083522)
```

!["get example 2"](assets/figures/get-example-2.png)

```julia
julia> simg = get(leonardo, rand(10, 16));
julia> using FileIO
julia> save("mosaic.png", simg)
```

!["get example 1"](assets/figures/get-example-1.png)

## Matplotlib compatibility

Most of the color schemes in Matplotlib are available. The following code example gives a general picture.

```@example
using ColorSchemes

# https://matplotlib.org/examples/color/colormaps_reference.html

matplotlibcmaps = Dict(
   :perceptuallyuniformsequential => [
      :viridis, :plasma, :inferno, :magma],
   :sequential => [
      :Greys_9, :Purples_9, :Blues_9, :Greens_9, :Oranges_9, :Reds_9,
      :YlOrBr_9, :YlOrRd_9, :OrRd_9, :PuRd_9, :RdPu_9, :BuPu_9,
      :GnBu_9, :PuBu_9, :YlGnBu_9, :PuBuGn_9, :BuGn_9, :YlGn_9],
   :sequential2 => [
      :binary, :gist_yarg, :gist_gray, :gray, :bone, :pink,
      :spring, :summer, :autumn, :winter, :cool, :Wistia,
      :hot, :afmhot, :gist_heat, :copper],
   :diverging => [
      :PiYG_11, :PRGn_11, :BrBG_11, :PuOr_11, :RdGy_11, :RdBu_11,
      :RdYlBu_11, :RdYlGn_11, :Spectral_11, :coolwarm, :bwr, :seismic],
   :cyclical => [
        :twilight, :twilight_shifted, :hsv],
   :qualitative => [
      :Pastel1_9, :Pastel2_8, :Paired_11, :Accent_8,
      :Dark2_8, :Set1_9, :Set2_8, :Set3_12,
      :tab10, :tab20, :tab20b, :tab20c],
   :miscellaneous => [
      :flag, :prism, :ocean, :gist_earth, :terrain, :gist_stern,
      :gnuplot, :gnuplot2, :CMRmap, :cubehelix, :brg, :hsv,
      :gist_rainbow, :rainbow, :jet, :nipy_spectral, :gist_ncar]
   )

for (k, v) in matplotlibcmaps
   println("$(rpad(k, 12)) $(length(v))")
   for cs in v
      try
         c = ColorSchemes.colorschemes[cs]
      catch
         println("\t$(rpad(cs, 12)) not currently in stock")
      end
   end
end
```

```@meta
DocTestSetup = quote
    using ColorSchemes, Colors
end
```
# Images

## A Julia Julia set: ColorSchemes and Images

Here's an example of how you can use ColorSchemes when creating images with Images.jl. The code creates a Julia set and uses a pre-defined ColorScheme extracted from Vermeer's painting "Girl with a Pearl Earring" (shown at the right for reference).

!["julia set"](assets/figures/julia-set-with-girl-pearl-vermeer.jpg)

```julia
using ColorSchemes, Images, FileIO
# and possibly QuartzImageIO (macOS) and/or ImageMagick (Linux)

function julia(z, c, maxiter::Int64)
    for n = 1:maxiter
        if abs(z) > 2
            return n
        end
        z = z^2 + c
    end
    return maxiter
end

# convert a value between oldmin/oldmax to equivalent value between newmin/newmax
remap(value, oldmin, oldmax, newmin, newmax) = ((value - oldmin) / (oldmax - oldmin)) * (newmax - newmin) + newmin

function draw(c, imsize;
      xmin = -1, ymin = -1, xmax  =  1, ymax = 1,
      filename = "/tmp/julia-set.png")
    imOutput = zeros(RGB{Float32}, imsize, imsize)
    maxiterations = 200
    for col = range(xmin, stop=xmax, length=imsize)
        for row = range(ymin, stop=ymax, length=imsize)
            pixelcolor = julia(complex(row, col), c, maxiterations) / 256
            xpos = convert(Int, round(remap(col, xmin, xmax, 1, imsize)))
            ypos = convert(Int, round(remap(row, ymin, ymax, 1, imsize)))
            imOutput[xpos, ypos] = get(ColorSchemes.vermeer, pixelcolor)
        end
    end
    save(filename, imOutput)
end

draw(-0.4 + 0.6im, 1200)
```

```@setup catalog
using Luxor, ColorSchemes, Colors

function draw_lightness_swatch(cs::ColorScheme, width = 800, height=150;
		name="")
	@drawsvg begin
		hmargin= 30
		vmargin= 20
		bb = BoundingBox(Point(-width/2 + hmargin, -height/2 + vmargin), Point(width/2 - hmargin, height/2 - vmargin))

		background("black")
		fontsize(8)
		sethue("white")
		setline(0.5)
		box(bb, :stroke)

		tickline(boxbottomleft(bb), boxbottomright(bb), major = 9, axis=false,
			major_tick_function = (n, pos; startnumber, finishnumber, nticks) ->
				text(string(n/10), pos + (0, 12), halign=:center)
			)

		tickline(boxbottomright(bb), boxtopright(bb), major = 9, axis=false,
			major_tick_function = (n, pos; startnumber, finishnumber, nticks) ->
				text(string(10n), pos + (0, 20), angle=π/2, halign=:right, valign=:middle)
			)

		text("lightness", boxtopleft(bb) + (10, 10), halign=:right, angle=-π/2)

		fontsize(12)
		L = 70
		sw = width/L
		saved = Point[]
		for i in range(0.0, 1.0, length=L)
			pos = between(boxmiddleleft(bb), boxmiddleright(bb), i)
			color = get(cs, i)
			setcolor(color)
			labcolor = convert(Lab, color)
			lightness = labcolor.l
			lightnesspos = pos + (0, boxheight(bb)/2 - rescale(labcolor.l, 0, 100, 0, boxheight(bb)))
			push!(saved, lightnesspos)
			circle(lightnesspos, 5, :fill)

		end

#		setline(1)
#		sethue("black")
#		line(saved[1], saved[end], :stroke)
#		setline(0.8)
#		line(saved[1], saved[end], :stroke)

        sethue("white")
		text(name, boxtopcenter(bb) + (0, -6), halign=:center)
	end width height
end
```

# Good practice

There are hundreds of colorschemes in this package, and they're useful for many different purposes. However, if you're intending to use a colorscheme for communicating features of a scientific dataset, you should choose it with care.

## Perceptual uniformity

You should choose a __perceptually uniform__ colorscheme: a set of colors arranged so that equal steps in data are _perceived_ by the viewer as equal steps in the color space.

Researchers[^Kovesi][^ZhouHansen] have found that the human brain perceives changes in the lightness parameter as changes in the data much better than, for example, changes in hue. So sequential colorschemes with monotonically increasing lightness values will be better interpreted by the viewer.

The **Lab color space** represents a color with three components: Lightness, RedGreen, and YellowBlue. The Lightness parameter can be used to indicate how uniform the colors will be perceived by viewers.

In the following diagrams, the Lightness Lab component of each color step is plotted in `y` as `x` moves through the colorscheme. You can see how the lightness increases evenly in the recommended schemes.

## Recommended

### Sequential

Good choices include `viridis`, `inferno`, `plasma`, `magma`:

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.viridis, 400, 150 ; name="viridis") # hide
d2 = draw_lightness_swatch(ColorSchemes.inferno, 400, 150 ; name="inferno") # hide
hcat(d1, d2) # hide
```

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.plasma, 400, 150 ; name="plasma") # hide
d2 = draw_lightness_swatch(ColorSchemes.magma, 400, 150 ; name="magma") # hide
hcat(d1, d2) # hide
```

ColorCET schemes (`findcolorscheme("colorcet")` will return the very long names to save you typing them):

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.linear_kbc_5_95_c73_n256, 400, 150 ; name="linear_kbc_5_95_c73_n256") # hide
d2 = draw_lightness_swatch(ColorSchemes.linear_tritanopic_krjcw_5_95_c24_n256, 400, 150 ; name="linear_tritanopic_krjcw_5_95_c24_n256") # hide
hcat(d1, d2) # hide
```

Fabio Crameri's Scientific colorschemes:

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.tokyo, 400, 150 ; name="tokyo") # hide
d2 = draw_lightness_swatch(ColorSchemes.devon, 400, 150 ; name="devon") # hide
hcat(d1, d2) # hide
```

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.hawaii, 400, 150 ; name="hawaii") # hide
d2 = draw_lightness_swatch(ColorSchemes.buda, 400, 150 ; name="buda") # hide
hcat(d1, d2) # hide
```

### Diverging

For diverging colorschemes, the lightness values of the extremes should be broadly equivalent.
As well as the `diverging-` ColorCET colorschemes, there are suitable schemes in Scientific, ColorBrewer, and others.

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.RdBu, 400, 150 ; name="RdBu") # hide
d2 = draw_lightness_swatch(ColorSchemes.BrBg, 400, 150 ; name="BrBg") # hide
hcat(d1, d2) # hide
```

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.RdBu, 400, 150 ; name="RdBu") # hide
d2 = draw_lightness_swatch(ColorSchemes.BrBg, 400, 150 ; name="BrBg") # hide
hcat(d1, d2) # hide
```

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.diverging_bwr_55_98_c37_n256, 400, 150 ; name="diverging_bwr_55_98_c37_n256") # hide
d2 = draw_lightness_swatch(ColorSchemes.diverging_rainbow_bgymr_45_85_c67_n256, 400, 150 ; name="diverging_rainbow_bgymr_45_85_c67_n256") # hide
hcat(d1, d2) # hide
```					  

## Less suitable for data visualization

Colorschemes with rapid changes in lightness are less suitable, because the viewer's interpretation of a region of data might be influenced by the coloring, rather than by the data values.

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.gnuplot, 400, 150 ; name="gnuplot") # hide
d2 = draw_lightness_swatch(ColorSchemes.jet, 400, 150 ; name="jet") # hide
hcat(d1, d2) # hide
```

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.Hiroshige, 400, 150 ; name="Hiroshige") # hide
d2 = draw_lightness_swatch(ColorSchemes.Hokusai1, 400, 150 ; name="Hokusai1") # hide
hcat(d1, d2) # hide
```

```@example catalog
using Luxor, ColorSchemes, Colors # hide
d1 = draw_lightness_swatch(ColorSchemes.dracula, 400, 150 ; name="dracula") # hide
d2 = draw_lightness_swatch(ColorSchemes.cubehelix, 400, 150 ; name="cubehelix") # hide
hcat(d1, d2) # hide
```

## References

[^Kovesi]:
	Good Colour Maps: How to Design Them |
	Peter Kovesi |
	arXiv:1509.03700 [cs.GR] |
	https://doi.org/10.48550/arXiv.1509.03700

[^ZhouHansen]:
	A Survey of Colormaps in Visualization |
	Liang Zhou, Charles D Hansen |
	https://pubmed.ncbi.nlm.nih.gov/26513793/

```@meta
DocTestSetup = quote
    using ColorSchemes, Colors
end
```

# Finding colors in colorschemes

ColorSchemes.jl provides the function `getinverse(cscheme, color)` which is the _inverse_ of `get(cscheme, n)`. This function returns a number between 0 and 1 that best represents the location of a color on the colorscheme's 'axis'.

!["get inverse"](assets/figures/getinverse.png)

```@docs
getinverse
```

## Example of using getinverse()

One example use for `getinverse()` is to convert a heatmap image into an Array of continuous values, e.g. temperature.

In this example, we will convert a heatmap image representing temperature into an array of elevation values. The image represents global temperature anomalies averaged from 2008 through 2012, with blue as -2°C and Red as +2°C. Higher than normal temperatures are shown in red (red is +2°C) and lower than normal temperatures are shown in blue (blue is -2°C). The global surface temperature in 2012 was +0.55°C. 

[NASA archive source](https://www.giss.nasa.gov/research/news/archive/20130115/).

```julia
using Images, FileIO, Downloads, ColorSchemes
img = Downloads.download("https://www.giss.nasa.gov/research/news/archive/20130115/719282main_2008_2012_printdata.1462.jpg") |> load
img = imresize(img, Tuple(Int(x) for x in size(img) .* 0.2));
display(img)
```

!["heatmap 1"](assets/figures/heatmap1.png)

```julia
temps = [getinverse(ColorSchemes.temperaturemap, pixel) for pixel in img]

432×768 Array{Float64,2}:
 0.975615  0.975615  0.975615  0.975615  …  0.975615  0.975615  0.975615
 0.975484  0.975767  0.975615  0.975615     0.975615  0.975615  0.975767
 0.975615  0.975615  0.975615  0.975615     0.975615  0.975615  0.975615
 0.975615  0.975615  0.975615  0.975615     0.975615  0.975615  0.975615
 0.975615  0.975615  0.975615  0.975615     0.975615  0.975615  0.975615
 0.975615  0.975615  0.975615  0.975615  …  0.975615  0.975615  0.975615
 0.975615  0.975615  0.975615  0.975615     0.975615  0.975615  0.975615
 0.975615  0.975615  0.975615  0.975615     0.975615  0.975615  0.975615
 ⋮                                       ⋱  ⋮                           
 0.820419  0.820084  0.819388  0.819388     0.819977  0.821949  0.81973
 0.816596  0.816055  0.816055  0.816055  …  0.819388  0.819388  0.818957
 0.813865  0.813247  0.813247  0.813247     0.816055  0.815452  0.813865
 0.810015  0.809307  0.809307  0.809307     0.813247  0.812582  0.812582
 0.808566  0.805171  0.805171  0.805171     0.810015  0.810015  0.809307
 0.804418  0.801045  0.80182   0.801045     0.805171  0.805171  0.805171
 0.801045  0.802513  0.802513  0.800252  …  0.804418  0.804308  0.801045
 0.802037  0.798624  0.798624  0.798624     0.802401  0.800252  0.802848
```

The image has been converted from its original colors to an array of continuous values between 0 and 1. This makes it possible to process as data. For example, we can find the places with the greatest anomalies:

```julia
mintemp, maxtemp = argmin(temps), argmax(temps)

 (CartesianIndex(397, 127), CartesianIndex(17, 314))
```

and these maximum and minimum 'coordinates' can be displayed on the image using another package that allows you to mix images, text, and vector graphics easily (such as Luxor.jl, for example).

```julia
save("/tmp/img.png", img)

using Luxor
pngimg = readpng("/tmp/img.png")

w, h = pngimg.width, pngimg.height

maxpt = Point(maxtemp[2], maxtemp[1]) # image and graphics coords need swapping
minpt = Point(mintemp[2], mintemp[1])

@png begin
    placeimage(pngimg, O, centered=true)
    translate(-w/2, -h/2)
    sethue("mediumseagreen")
    fontsize(20)
    fontface("Avenir-Black")
    setopacity(0.75)
    circle(maxpt, 5, :fill)
    label("largest positive anomaly", :E, maxpt, offset=20)
    circle(minpt, 5, :fill)
    label("largest negative anomaly", :E, minpt, offset=20)
end 800 460
```

!["heatmap min and max"](assets/figures/heatmap4.png)

We can display the array of continuous values as a grayscale image, where black is 0.0 and white is 1.0.

```julia
Gray.(temps)
```

!["heatmap 2 grey"](assets/figures/heatmap2.png)

```@meta
DocTestSetup = quote
    using ColorSchemes, Colors
end
```

# Introduction to ColorSchemes
This package provides a collection of colorschemes:

- scientifically devised colorschemes from ColorBrewer, CMOcean, ScientificColorMaps, ColorCet, and Seaborn
- popular favourites such as _viridis_, _inferno_, and _magma_ from MATPlotLib
- variously themed colorschemes such as _sunset_, _coffee_, _neon_, and _pearl_
- artistic colorschemes, such as _leonardo_, _vermeer_, _picasso_, _Degas_, _Hiroshige_,  

Note that the schemes contained here are a mixture:

- some are high quality color maps with consistent perceptual contrast over their full range
- others are designed for general purpose and informal graphics work

Choose colorschemes with care! See the [Good practice](@ref) section, and also refer to Peter Kovesi's [PerceptualColourMaps](https://github.com/peterkovesi/PerceptualColourMaps.jl) package, or to Fabio Crameri's [Scientific Colour Maps](http://www.fabiocrameri.ch/colourmaps.php) for technical information.

This package relies on the [Colors.jl](https://github.com/JuliaGraphics/Colors.jl) package.

If you want to make more advanced ColorSchemes, use linear-segment dictionaries or indexed lists, and use functions to generate color values, see the `make_colorscheme()` function in the [ColorSchemeTools.jl](https://github.com/JuliaGraphics/ColorSchemeTools.jl) package.

## Installation and basic usage

Install the package as follows:

```julia
import Pkg
Pkg.add("ColorSchemes")
```

or, at the REPL:

```julia
] add ColorSchemes
```

Usage:

```julia
using ColorSchemes

ColorSchemes.Purples_5 
# => a ColorScheme 

colorschemes[:Purples_5]
# => a ColorScheme 

ColorSchemes.Purples_5.colors
# => array of five RGB colors

ColorSchemes.Purples_5.colors[3]
# => the third color in the colorscheme

get(ColorSchemes.Purples_5, 0.5)
# => the midway point of the colorscheme 

colorschemes
# => Dict{Symbol, ColorScheme} with 1150 entries

findcolorscheme("purple")
# => display list of matching schemes

ColorScheme([colorant"red", colorant"green", colorant"blue"])
# new colorscheme from Colors.jl named colors

get(ColorSchemes.darkrainbow, range(0.0, 1.0, length=20)) |> ColorScheme
# new colorscheme by resampling existing

resample(ColorSchemes.darkrainbow, 20)
# new colorscheme by resampling using `resample()` 
```

Original version by [cormullion](https://github.com/cormullion).

## Contributing a new colorscheme

If you think a new colorscheme would be a great addition for you and for Julians everywhere, you can contribute it as follows:

1 Add a file to the `data/` directory. The file should be a Julia file, with a `.jl` suffix.

2 Inside the file, define a colorscheme in this format, which calls [loadcolorscheme](@ref):

```julia
loadcolorscheme(:mynewcolorscheme, [
    RGB(0.0, 0.0, 0.0),
    RGB(0.5, 0.5, 0.5),
    RGB(1.0, 1.0, 1.0),
    ], 
    "category for my new scheme", # the category
    "black, white, and grey" # some descriptive keywords
    )
```

The new name - here `mynewcolorscheme` - should be a valid Julia variable name.

3 If you're adding the new colorscheme to an existing category, it will appear in the catalog document automatically.

4 Otherwise, to add a new category to the catalog (which will add all the colorschemes in that category), add this code to `catalogue.md`:

```markdown
    ```@example catalog
    using Luxor, ColorSchemes # hide
    ColorSchemeCategory("category for my new scheme") # hide
    ```
```

5 If there's a license file, add it to `data/` as well.

## Documentation

This documentation was built using [Documenter.jl](https://github.com/JuliaDocs).

```@example
using Dates # hide
println("Documentation built $(Dates.now()) with Julia $(VERSION)") # hide
```

# References

## ✦ cmocean

From "Beautiful colormaps for oceanography": [cmocean](https://matplotlib.org/cmocean/)

## ✦ scientific

From [Scientific colormaps](http://www.fabiocrameri.ch/colourmaps.php)

## ✦ matplotlib

From [matplot](https://matplotlib.org)

## ✦ colorbrewer

From [ColorBrewer](http://colorbrewer2.org/)

## ✦ gnuplot

From [GNUPlot](http://www.gnuplot.info)

## ✦ colorcet

From ["collection of perceptually accurate colormaps"](https://colorcet.holoviz.org)

## ✦ Seaborn

From ["colorschemes used by Seaborn, a Python data visualization library based on matplotlib."](http://seaborn.pydata.org/tutorial/color_palettes.html)

## ✦ ggthemes/tableau

From ["ggthemes tableau palettes"](https://github.com/jrnold/ggthemes)

## ✦ CVD/(ColorBlind)-friendly schemes

Colorschemes designed with color-vision deficient users in mind, by authors such as Paul Tol, Masataka Okabe, Kei Ito, and Martin Krzywinski.

## ✦ Flags

Colors extracted from flags of different countries and regions, downloaded from
[Flagpedia](https://flagpedia.net). Intended to represent these regions in
visualizations, but not necessarily effective. Many flags have similar
colorschemes. The flags are named according to the region's ISO3166 two-letter
abbreviation (often the same as top-level WWW domain), with any hyphens removed.

## ✦ general and miscellaneous

```@setup catalog
# this code will display all the schemes in a category, as an SVG.
# Use in this docs/src/catalogue.md file as
#  ```@example catalog
#     using Luxor, ColorSchemes # hide
#     ColorSchemeCategory("cmocean") # hide
#  ```
# which displays the "cmocean" category

using Luxor, ColorSchemes

struct ColorSchemeGroup
    name::String
end

function generate_scheme_svg(schemename;
        swatchwidth = 800,
        swatchheight = 20)
    # create swatch
    cols = colorschemes[schemename].colors
    l = length(cols)
    Drawing(swatchwidth, swatchheight, :svg)
    origin()
    t = Tiler(swatchwidth, swatchheight, 1, l, margin=0)
    setline(0.5)
    for (i, c) in enumerate(cols)
        sethue(c)
        box(t, i, :fillstroke)
    end
    finish()

    swatch = svgstring()

    # fill the template
    schemetemplate = """
    <div class="schemename"><h2>$(schemename)

        <span class="hovertext" data-hover=
        "name: $(schemename),
        length: $(length(colorschemes[schemename])),
        category: $(colorschemes[schemename].category), notes: $(colorschemes[schemename].notes).">※</span>

    </h2>
    <div class="swatch">$(swatch)</div>
    </div>
    """
    return schemetemplate
end

function generate_schemes_in_category(category)
    iobuffer = IOBuffer()

    write(iobuffer, """
    <div class="category">
      """)

    schemes = filter(s -> occursin(category, colorschemes[s].category), collect(keys(colorschemes)))
    for s in sort(schemes, lt = (s1, s2) -> lowercase(string(s1)) < lowercase(string(s2)))
        write(iobuffer, generate_scheme_svg(s))
    end
    write(iobuffer, """
    </div>
    """)

    return String(take!(iobuffer))
end

function generate_schemes_matching_notes_string(str)
    iobuffer = IOBuffer()

    write(iobuffer, """
    <div class="category">
      """)

    schemes = filter(s -> occursin(str, colorschemes[s].notes), collect(keys(colorschemes)))
    for s in sort(schemes, lt = (s1, s2) -> lowercase(string(s1)) < lowercase(string(s2)))
        write(iobuffer, generate_scheme_svg(s))
    end
    write(iobuffer, """
    </div>
    """)

    return String(take!(iobuffer))
end

function Base.show(io::IO, m::MIME"text/html", category::ColorSchemeCategory)
     print(io, generate_schemes_in_category(category.name))
end

function Base.show(io::IO, m::MIME"text/html", group::ColorSchemeGroup)
     print(io, generate_schemes_matching_notes_string(group.name))
end
```

# Catalogue of ColorSchemes

At the REPL you can search for colorschemes by name:

```julia
findcolorscheme("julia")
```

# cmocean

From "Beautiful colormaps for oceanography": [cmocean](https://matplotlib.org/cmocean/)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("cmocean") # hide
```

# scientific

From [Scientific colormaps](http://www.fabiocrameri.ch/colourmaps.php)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("scientific") # hide
```

# matplotlib

From [matplot](https://matplotlib.org)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("matplotlib") # hide
```

# colorbrewer

From [ColorBrewer](http://colorbrewer2.org/)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("colorbrewer") # hide
```

# gnuplot

From [GNUPlot](http://www.gnuplot.info)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("gnuplot") # hide
```

# colorcet

From ["collection of perceptually accurate colormaps"](https://colorcet.holoviz.org)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("colorcet") # hide
```

# CMasher

From ["Scientific colormaps for making accessible, informative and cmashing plots"](https://cmasher.readthedocs.io/)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("CMasher") # hide
```

# Seaborn

From ["colorschemes used by Seaborn, a Python data visualization library based on matplotlib."](http://seaborn.pydata.org/tutorial/color_palettes.html)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("seaborn") # hide
```

# ggthemes/tableau

From ["ggthemes tableau palettes"](https://github.com/jrnold/ggthemes)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("tableau") # hide
```

# Color-Vision Deficient-friendly schemes

Colorschemes designed with color-vision deficient users in mind, by authors such as Paul Tol, Masataka Okabe, Kei Ito, and Martin Krzywinski. This list also includes schemes with "cvd" in the Notes field.

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("cvd") # hide
ColorSchemeGroup("cvd") # hide
```

# Flags

Colors extracted from flags of different countries and regions, downloaded from
[Flagpedia](https://flagpedia.net). Intended to represent these regions in
visualizations, but not necessarily effective. Many flags have similar
colorschemes. The flags are named according to the region's ISO3166 two-letter
abbreviation (often the same as top-level WWW domain), with any hyphens removed.

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("flags") # hide
```

# MetBrewer

Palettes inspired by works at the Metropolitan Museum of Art
in New York. See [Blake Mills' github
repository](https://github.com/BlakeRMills/MetBrewer).

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("MetBrewer") # hide
```

# Pacific North West

The colors of Washington State and the Pacific Northwest of the USA. See [Jake Lawlor's github
repository](https://github.com/jakelawlor/PNWColors).

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("PNW Pacific North West") # hide
```

# Wes Anderson

Palettes derived from the films of Wes Anderson. See [Karthik's github
repository](https://github.com/karthik/wesanderson).

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("Wes Anderson") # hide
```

# Ghibli

Palettes derived from the films of Studio Ghibli. See [Ewenme's github
repository](https://github.com/ewenme/ghibli).

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("Ghibli") # hide
```

# Catppuccin

Catppuccin is a community-driven pastel theme that aims to be the middle
ground between low and high contrast themes. It consists of 4 soothing
warm flavors with 26 eye-candy colors each, perfect for coding, designing,
and much more! See [Catppuccin main project](https://github.com/catppuccin)

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("Catppuccin") # hide
```

# Feathers
Palattes derived from the plumage of Australian birds. See [Shandiya's github
repository](https://github.com/shandiya/feathers).

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("Feathers") # hide
```

# general and miscellaneous

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("general") # hide
```

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("nord") # hide
```

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("kindlmann") # hide
```

# Julia logo colorschemes

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("julia") # hide
```

# Pride colorschemes

```@example catalog
using Luxor, ColorSchemes # hide
ColorSchemeCategory("pride") # hide
```
